;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram (VT-DOS -hoz mdostva)
;
;-----------------------------------------------------------------
;


vmodes	.dw	fv_vmod0, fv_vmod1, fv_vmod2

;
;	Megjelentsi md belltsa
;	in:   A - megjelensi md sorszma (bit1..0)
;	out:    - 
;
fk_vmode:
	and	003h			; belltand md sorszmnak ellenrzse
	cp	3
	jr	c,fk_vmd0
	xor	a
fk_vmd0:ld	(sdcvmode),a		; md mentse
	add	a,a
	ld	e,a
	ld	d,000h
	ld	hl,vmodes
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	push	de
	pop	iy			; IY  a kivlasztott grafikus megjelents paramtereire mutat
	ret

;
;	Fjlkezel egyszerstet indtsa
;	in:   A - inicializlsi md (bit2) s megjelensi md sorszma (bit1..0)
;	out:    - 
;
fk_start:
	push	iy
	push	af
	call	fk_pinit		; panelek inicializlsa a soft bit-nek megfelelen
	pop	bc
	ld	a,b
	jr	c,fk_in0		; ugrs, ha teljes inicializls kell
	ld	a,(sdcvmode)		; elz futs alatti videmd A reg.-be
fk_in0:	call	fk_vmode		; megjelentsi md inicializlsa
;
	ld	a,000h			; A reg.= aktulis vide zemmd (most fixen 2-szn md)
	ld	(origvmode),a		; zemmd mentse
;
					; kiindulsi tvonal meghatrozsa
	ld	hl,fk_err_handler	; HL= belltand cm
	call	fk_set_errhand		; hibakezel rutin belltsa
;
	ld	a,01Fh			; parancskd: diszk-ROM verziszm beolvassa
	call	fk_fish			; FISH funkci hvsa
	bit	0,b			; f verziszm 0. bitjnek vizsglata
	ld	a,0F0h			; memrialapozs: U0,U1,U2,EXT/IOMEM
	jr	nz,fk_opn0		; ugrs, ha interfsz krtya
	ld	a,030h			; memrialapozs: U0,U1,U2,CART
fk_opn0:ld	(diskpg),a		; diszk RAM memrialapozsi rtknek mentse
	ld	b,000h			; B= vltoz rtknek olvassa lesz
	ld	e,021h			; E= DEF_UNIT vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz beolvassa
	call	fk_fish			; FISH funkci hvsa
	ld	b,d			; B= DEF_UNIT vltoz
	ld	hl,(path_ptr)
	ld	a,(hl)
	or	a
	jr	nz,fk_op0		; ugrs, ha van rvnyes tvonal
	push	bc			; DEF_UNIT vltoz a verembe is
	ld	a,003h			; parancskd: aktulis knyvtr beolvassa
	call	fk_fish			; FISH funkci hvsa
	pop	bc
	or	a
	jr	nz,fk_op0		; ugrs, ha hiba trtnt (pl. nincs krtya behelyezve)
	di
	ld	a,(diskpg)		; A reg.= diszk RAM memrialapozsi rtke
	out	(002h),a		; lapozs belltsa
	call	pathcp0			; HL mutatta tvonalstring tmsolsa az U0 RAM-ba
	ld	a,(0003Bh)		; lapozs vissza
	out	(002h),a
	ei
	ld	a,b			; A= DEF_UNIT  vltoz
	add	a,040h			; meghajt betjelnek meghatrozsa
	ld	de,(path_ptr)
	ld	(de),a			; meghajt betjele
	inc	de
	ld	a,':'
	ld	(de),a
	inc	de
	ld	a,92			; '\'
	ld	(de),a
	inc	de
	ld	hl,strbuff		; tvonalstring tmsolsa az U0 RAM-bl a sajt RAM-ba
	call	pathcp1			; msols a HL mutatta cmtl a lezr nullig
fk_op0:	ld	e,3			; teljes frissts
fk_opc:	call	fk_refresh		; kperny frisstse
	ld	a,(akt_ln)		; az aktulis sor inverz megjelentse
	call	fk_linv
	call	fk_clnkey		; billentyzet-puffer kitakartsa
fk_op1:	call	fk_aktfadr		; aktulis fjlnvcm kiolvassa
	call	fk_name_bj		; kurzor alatti nv a fjlnv pufferbe (jrarajzolskor ide scrolloz)
	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	cp	0F8h			; bal oldali joystick rtkeinek konvertlsa
	jr	c,fk_op2c		; ugrs, ha nem bal-tz
	ld	a,0E8h
fk_op2c:cp	0FCh
	jr	c,fk_op2		; ugrs, ha nem bal joy irny
	and	01Fh
fk_op2:	call	fk_nagy			; kisbetk nagybetv konvertlsa
	cp	01Fh			; JOY le
	jr	nz,fk_op4
fk_op2b:ld	a,(nbj)			; bejegyzsek szma
	ld	b,a
	ld	a,(xaktbj)
	ld	(rec_level),a		; aktulis bejegyzs indexnek elmentse scrollozs esetre
	inc	a
	cp	b
	jr	z,fk_op1		; ugrs, ha ez volt az utols tallt bejegyzs
	ld	(xaktbj),a
	ld	a,(akt_ln)
	call	fk_linv			; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	inc	a
	ld	(akt_ln),a
	dec	a
	cp	IY_LSTLN		; utols sorban volt korbban?
	jr	nz,fk_op3
	ld	(akt_ln),a		; ha igen, helybenmarad
	call	fk_scup			; s scroll felfel
	ld	c,IY_LSTLN		; Y= utols sor
fk_op3a:push	bc			; (itt scrollozskor trlni kell a sort a kijellsek miatt, kivve ha az a szveggel azonos hosszsg)
	ld	a,(rec_level)		; a trlend sorban lv fjlnv cmnek kiolvassa
	call	fk_fad0
	ld	de,11
	add	hl,de			; HL= attribtum bjt cme
	ld	h,(hl)			; a 7. bit jelzi, ha ki van jellve a fjl
	ld	a,(akt_ln)
	call	fk_fninv		; sor invertlsa az esetleges kijells miatt
	pop	bc
	call	fk_aktfadr		; aktulis fjlnvcm kiolvassa
	call	fk_fnir			; formzott fjlnv kirsa
fk_op3:	ld	a,(akt_ln)
	call	fk_linv
	jp	fk_op1
fk_op4:	cp	01Eh			; JOY fel
	jr	nz,fk_op6
	ld	a,(xaktbj)
	ld	(rec_level),a		; aktulis bejegyzs indexnek elmentse scrollozs esetre
	dec	a
	cp	0FFh
	jp	z,fk_op1		; ugrs, ha ez volt a legels bejegyzs
	ld	(xaktbj),a
	ld	a,(akt_ln)
	call	fk_linv			; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	dec	a
	ld	(akt_ln),a
	cp	IY_FSTLN		; els eltti sor?
	jr	nc,fk_op3
	inc	a
	ld	(akt_ln),a		; ha igen, helybenmarad
	call	fk_scdw			; s scroll lefel
	ld	c,IY_FSTLN		; Y= els sor
	jp	fk_op3a
fk_op6:	cp	00Dh			; RETURN
	jr	z,fk_op7
	cp	0E8h			; JOY tz
	jr	nz,fk_op8
fk_op7:	call	fk_slct
	jp	c,fk_op12b		; ugrs, ha knyvtrvlts volt
	jp	fk_op1			; ugrs, ha nem trtnt fjl-kivlaszts
fk_op8:	ld	b,001h			; rendezsi szempont vltsa
	cp	'N'
	jr	z,fk_op9		; ugrs, ha nv szerint
	inc	b
	cp	'K'
	jr	z,fk_op9		; ugrs, ha kiterjeszts szerint
	inc	b
	cp	'M'
	jr	z,fk_op9		; ugrs, ha mret szerint
	inc	b
	cp	'D'
	jr	nz,fk_op11		; ugrs, ha nem dtum szerint
fk_op9:	ld	a,(sorttype)		; korbbi rendezsi md A reg.-be
	and	07Fh
	cp	b
	ld	a,b
	jr	nz,fk_op10		; ugrs, ha a rendezsi szempont vltozott
	ld	a,(sorttype)		; korbbi rendezsi md ismt A reg.-be
	xor	080h			; rendezsi irny bit invertlsa
fk_op10:ld	(sorttype),a
	ld	e,0
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
fk_op11:cp	'1'			; #1 panel kivlasztsa
	jr	z,fk_op12
	cp	'2'			; #2 panel kivlasztsa
	jr	z,fk_op12
	cp	01Ch			; JOY jobbra
	jr	z,fk_op12a
	cp	01Dh			; JOY balra
	jr	nz,fk_op13
fk_op12a:
	ld	e,IY_GRMODE		; grafikusmd E-be
	bit	5,e
	jp	z,fk_op1		; ugrs, ha egypaneles md
	and	007h
	add	a,'0'-2			; gyakorlatilag ugyanaz, mintha kzvetlenl az #1 v. #2 panelt vlasztannk
fk_op12:sub	'1'
	ld	e,a			; E= vlasztott panel index (0 v. 1)
	ld	a,(akt_panel)
	cp	e
	jp	z,fk_op1		; ugrs, ha nem vltozott az aktulis panel
	ld	a,(akt_ln)
	call	fk_linv			; rgi sor vissza-invertlsa
;
	ld	b,IY_MAXLN		; B= maximlisan kirhat sorok szma
	ld	c,IY_FSTLN		; C= az els sor szma
fk_op12c:
	push	bc
	ld	a,c
	ld	b,000h			; B= vezrl bjt, 000h -> csak visszainvertl
	call	fk_fndesel		; fjlnv visszainvertlsa, ha ki van vlasztva
	pop	bc
	inc	c
	djnz	fk_op12c
;
	call	fk_pakt			; inaktv panel kivlasztsa
fk_op12b:
	ld	e,2
	jp	fk_opc			; ugrs az j knyvtr beolvassra
fk_op13:cp	'0'			; a kt panel felcserlse
	jr	nz,fk_op15
	call	fk_pxch			; panelek felcserlse gy, hogy az eredetileg megjelentett knyvtr ltszdjon
	jp	fk_op0			; ugrs a kperny jbli kirajzolsra
;
fk_op15:cp	0ECh			; INS
	jr	nz,fk_op16
	call	fk_aktfadr		; aktulis fjlnvcm kiolvassa
	ld	de,11
	add	hl,de
	ld	a,(hl)
	xor	080h			; 7. bit invertlsa 
	ld	(hl),a
;
;	ld	e,5			; a kvetkez kdrszben a kijellt fjlok sszmrett szmolja, de ez most nincs megjelentve
;	add	hl,de			; HL a fjlmretre mutat
;	ld	e,(hl)			; fjlmret BC:DE-be
;	inc	hl
;	ld	d,(hl)
;	inc	hl
;	ld	c,(hl)
;	inc	hl
;	ld	b,(hl)
;	bit	4,a			; knyvtr-bit ellenrzse
;	jr	nz,fk_op6d		; ugrs, ha alknyvtr
;	ld	hl,(selcap)		; HL-be a kivlasztott fjlok sszmretnek als szava
;	and	080h
;	jr	z,fk_op6b		; ugrs, ha cskkent a kivlasztott fjlok szma
;	add	hl,de			; sszmret nvelse a fjl mretvel
;	ld	(selcap),hl
;	ld	hl,(selcap+2)
;	adc	hl,bc
;	jr	fk_op6c
;fk_op6b:sbc	hl,de			; sszmret cskkentse a fjl mretvel
;	ld	(selcap),hl
;	ld	hl,(selcap+2)
;	sbc	hl,bc
;fk_op6c:ld	(selcap+2),hl
;
fk_op6d:and	080h
	rlca				; legfels bit CY-be is
	dec	a			; ez nem lltja CY-t
	ld	b,a
	ld	a,(nselect)
	adc	a,b
	ld	(nselect),a
	ld	a,(akt_ln)
	call	fk_fninv0		; sor invertlsa a kpernyn	
;	call	fk_clsm			; als sor trlse  !!! sszest sor kirsa tl lass, ezrt egyelre kikommentezve
;	call	fk_suml			; sszest sor frisstse  !!! ld. mg "fk_suml" rutinnl is
	jp	fk_op2b			; ugrs a kijell sor eggyel lejjebb lptetsre
fk_op16:cp	'3'
	jr	nz,fk_op17		; ugrs, ha nem '3'
;
	CALL_FKTVIEW			; fjl megnzse
;
	ld	e,3
	jp	nc,fk_opc		; ha megjelentette, ugrs a kperny jbli kirajzolsra
	jp	fk_op1			; egybknt, csak vr a kvetkez billentyre
fk_op17:cp	0EFh			; SHIFT + DEL -> trls
	jr	z,fk_op18
	cp	'4'
	jr	c,fk_op19		; ugrs, ha '4'-nl kisebb
	cp	'7'+1
	jr	nc,fk_op19		; ugrs, ha '7'-nl nagyobb
fk_op18:
;
	CALL_FKFUNC			; fjlkezelsi funkci vgrehajtsa
;
	call	fk_erff			; hiba kirsa
	jp	nc,fk_op0		; ha frissteni kell, ugrs a knyvtr ismtelt beolvassra
	jr	fk_op1B			; ugrs a kperny jbli kirajzolsra
;
fk_op19:cp	'S'
	jr	nz,fk_op1A		; ugrs, ha nem 'S'
	call	fk_pal0			; teljesen fekete paletta belltsa
;
	CALL_FKSUGO			; sg megjelentse
;
	ld	e,1
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
;
fk_op1A:cp	'V'
	jr	nz,fk_op20		; ugrs, ha nem 'V'
	call	fk_basic		; vlts BASIC-be
fk_op1B:call	fk_clsm			; als sor trlse
	ld	e,0
	jp	fk_opc			; ha mgsem, akkor ugrs a kperny jbli kirajzolsra
;
fk_op20:cp	'F'
	jr	nz,fk_op21		; ugrs, ha nem 'F'
	call	fk_free_wrapper		; szabad terlet szmtsa s kirsa
	or	a
	jp	nz,fk_op12b		; ha hiba trtnt, ugrs a knyvtr ismtelt beolvassra
	jp	fk_op1
fk_op21:cp	'G'
	jr	nz,fk_op22		; ugrs, ha nem 'G'
	ld	a,(sdcvmode)
	inc	a
	call	fk_vmode		; IY a kvetkez grafikus megjelents paramtereire mutat
	ld	e,1
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
fk_op22:cp	27			; ESC
	jp	nz,fk_op1
	ld	a,0FFh			; A=0xFF ->CANCEL
fk_end:	push	af
	push	de			; visszatrsi rtkek a verembe
	push	hl
	call	fk_pal0			; teljesen fekete paletta belltsa
	ld	a,(origvmode)		; belpskori videzemmd visszalltsa
	ld	c,a			; GRAPHICS x, kperny trlse
	call	ed_vidmode
	call	fk_aktfadr		; aktulis fjlnvcm kiolvassa
	call	fk_name_bj		; kurzor alatti nv a fjlnv pufferbe (jraindtskor ide scrolloz)
	call	fk_pakt			; fjlnv kimentse a panel adatterletre
	call	fk_pakt
	call	fk_setpath		; aktulis tvonal belltsa
	pop	hl
	pop	de
	pop	af
	pop	iy
	ret


;
;	Aktulis tvonal belltsa a kivlasztott fjlnak megfelelen
;	in:  -
;	out: -
;
fk_setpath:
	call	pathcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	a,(strbuff)
	or	a
	jr	nz,fk_set0		; ugrs, ha nem a meghajt-listban van
	ld	(strbuff+1),a
	ld	a,92			; '\'
	ld	(strbuff),a		; gykrknyvtr belltsa
	ld	hl,(akt_bj)		; aktulis bejegyzs cme
	ld	a,(hl)			; A reg.-be a kurzorpozcinak megfelel meghajt betjele
	cp	'<'
	jr	nz,fk_set0		; ugrs, ha van zemksz meghajt
	ld	a,'A'
fk_set0:sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	d,a			; D= meghajt sorszm

;
;	Aktulis tvonal belltsa a stringbufferbl
;	in:  D - meghajt sorszma (A->1 B->2 ..)
;	out: -
;
fk_setpath_sbuff:
	ld	b,0FFh			; B= vltoz rtknek rsa lesz
	ld	e,021h			; E= DEF_UNIT vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz belltsa
	call	fk_fish			; FISH funkci hvsa
	ld	hl,strbuff		; HL= tvonalnv kezdete
	ld	a,002h			; A = FISH funkci: knyvtr-vltoztats
	call	fk_fish			; FISH funkci hvsa
	ld	hl,00000h		; HL= belltand cm
	call	fk_set_errhand		; hibakezel rutin nullzsa
	ret

;
;	A fjlkezel kls hibakezelje
;
fk_err_handler:
	ld	a,001h
	ret

;
;
;	A fjlkezel kls hibakezeljnek belltsa
;	in:  HL - belltand hibakazel rutin cme (0000h - nincs hibakezel rutin)
;	out:    -
;
fk_set_errhand:
	ex	de,hl			; rutincm DE-be
	ld	c,083h			; C= funkcikd: diszk-hiba szubrutin definilsa
	call	0005h			; VT-DOS hvsa
	ret


;
;-----------------------------------------------------
;	Panelek kezelse
;-----------------------------------------------------
;

;
;	Alap panel-belltsok
;
def_pan	.db	SORT_KIT		; panel 1.
	.dw	pathbuff1
	.db	000h
;
	.db	SORT_KIT		; panel 2.
	.dw	pathbuff2
	.db	000h

;
;	tvonalnv mutatk ellenrzse
;	in:  BC - vizsgland mutat_1
;	     DE - vizsgland mutat_2
;	out: BC - megrzdik
;	     DE - megrzdik
;	     ZF - ZF=1 -> rendben van (ilyenkor mg CY=0)
;
fk_ppch:ld	hl,pathbuff1
	or	a
	sbc	hl,bc
	ret	nz			; visszatrs, ha mr az els mutat sem j
	ld	hl,pathbuff2
	sbc	hl,de
	ret

;
;	Panelek alaphelyzetbe lltsa
;	in:   A - inicializlsi md (bit2 = 1 -> soft init)
;	out: CY - CY=1 -> teljes inicializls kellett
;
fk_pinit:
	and	004h			; soft bit vizsglata
	jr	z,fk_pin0		; ugrs, ha teljes inicializls kell
	ld	bc,(path_ptr_1)		; tvonalnv mutatk ellenrzse
	ld	de,(path_ptr_2)
	call	fk_ppch			; egyik sorrend
	push	bc
	push	de
	pop	bc
	pop	de
	call	nz,fk_ppch		; msik sorrend, ha az els nem volt j
	jr	nz,fk_pin0		; teljes inicializls, ha rossz valamelyik mutat
	ld	a,(akt_panel)		; aktulis panel
	ld	hl,sorttype_2
	and	001h			; CY=0
	jr	nz,fk_pin2		; ugrs, ha a 2. panel lehetett az aktv
	jr	fk_pin1			; egybknt az 1. panel kivlasztsa
;
fk_pin0:ld	hl,def_pan
	ld	de,sorttype_1
	ld	bc,0004h		; BC= msoland hossz
	ldir
	ld	de,sorttype_2
	ld	c,4
	ldir
	xor	a			; 1. panel kivlasztsa
	ld	(pathbuff1),a		; meghajt tvonalak trlse
	ld	(pathbuff2),a
	scf				; CY=1
fk_pin1:ld	hl,sorttype_1		; HL az 1. panel adataira mutat
fk_pin2:ld	(akt_panel),a		; aktulis panel
	ld	de,sorttype		; DE a munkaterletre mutat
	ld	bc,0003h		; aktv panel adatainak tmsolsa
	ldir
	ld	de,fnamebuff
	ld	c,13
	ldir
	ret

;
;	Panelek felcserlse
;	in:     -
;	out:    -
;
fk_pxch:ld	a,(akt_panel)		; aktulis panel
	xor	001h
	ld	(akt_panel),a		; az inaktvat jelzi aktvnak
	ld	hl,sorttype_1
	ld	de,sorttype_2
	jr	z,fk_pxc0		; ugrs, ha a 2. panel az aktv
	ex	de,hl
fk_pxc0:ld	bc,16			; az inaktv panel adatainak tmsolsa az aktv panelre
	ldir				; majd folytats az eredeti aktulis panel visszalltsval

;
;	Inaktv panel kivlasztsa
;	in:     -
;	out:    -
;
fk_pakt:ld	a,(akt_panel)
	xor	001h			; panel sorszm invertlsa
	ld	e,a

;
;	Panel kivlasztsa
;	in:   E - a belltand panel indexe (0 vagy 1)
;	out: CY - CY=1 -> ktpaneles md
;
fk_psel:ld	a,(akt_panel)
	cp	e
	ret	z			; visszatrs, ha nem kell vltani, CY=0
	ld	a,e
	ld	(akt_panel),a
	ld	hl,sorttype_1
	ld	de,sorttype_2
	jr	nc,fk_psl0		; ugrs, ha az 1. panelt kell kivlasztani
	ex	de,hl
fk_psl0:push	hl			; aktulis paneladatok kimentse
	ld	hl,sorttype
	push	hl
	ld	bc,0003h
	ldir
	ld	hl,fnamebuff
	ld	c,13
	ldir
	pop	de			; j panel belltsa
	pop	hl
fk_psl1:ld	c,3
	ldir
	ld	de,fnamebuff
	ld	c,13
	ldir
fk_psl2:ld	b,a			; B= kivlasztott panel
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	020h
	jr	z,fk_psl3		; ugrs, ha egypaneles md
	scf				; CY= 1 -> ktpaneles md
	dec	b
	jr	z,fk_psl3		; ugrs, ha a 2. panel van kivlasztva
	ld	a,000h
fk_psl3:ld	(namecl_offs),a
	ret

;
;	Kpernytartalom frisstse
;	in:   E - 0.bit=1 -> a teljes kpernyt frissteni kell  1.bit=1 -> a knyvtr tartalmat is frissteni kell
;	out:    -
;
fk_refresh:
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	020h
	jr	z,fk_ref1		; ugrs, ha egy-paneles md
	bit	0,e
	jr	z,fk_ref1		; ugrs, ha kt-paneles md s rszleges frissts
;
	call	fk_bord_wrap		; httr s keret rajzolsa
	call	fk_keyinfo		; ideiglenesen: billenty infk kirsa
	call	fk_ref0			; inaktv panel kivlasztsa s frisstse
fk_ref0:call	fk_pakt			; aktulis panel helyrelltsa
	call	fk_dir_rfrsh		; knyvtr frisstse
	jr	fk_ref2
;
fk_ref1:push	de			; flag-ek mentse
	bit	1,e
	call	nz,fk_dir_rfrsh		; knyvtr frisstse, ha szksges
	pop	de
	call	fk_bord_wrap		; httr s keret rajzolsa
	call	fk_keyinfo		; ideiglenesen: billenty infk kirsa
fk_ref2:call	fk_sort			; fjlnevek rendezse
	call	fk_ffnv			; aktulis fjlnv keresse
	call	fk_dspl			; knyvtrtartalom megjelentse
	call	fk_suml			; sszest sor kirsa
	ret


;
;-----------------------------------------------------
;	Knyvtr s fjl-kivlaszt mveletek
;-----------------------------------------------------
;

;
;	Knyvtr beolvassa
;	in:  -
;	out: ;ZF - ZF=0 -> nem kezelhet hiba trtnt
;
fk_dir_rfrsh:
	ld	a,002h
	ld	(retry_cnt),a		; jraprblkozsok szma= 2
fk_drf0:call	fk_dir			; az adott knyvtr tartalmnak beolvassa
	call	fk_err			; hiba kezelse
	jr	c,fk_drf0		; ha ellenrzs utn CY=1 -> jra prblkozik
	ld	a,00Eh			; parancskd: szektorpufferek trlse (krtyacsere esetre)
	ld	bc,0FFFFh		; minden meghajtra vonatkozik a parancs
	call	fk_fish			; FISH funkci hvsa
	xor	a
	ld	(nselect),a		; kivlasztott fjlok szmnak nullzsa
;	ld	h,a
;	ld	l,a
;	ld	(selcap),hl		; kivlasztott mret nullzsa
;	ld	(selcap+2),hl
	ret

;
;	Hibakezels knyvtrbeolvass utn
;	in:   A - hibakd
;	out: CY - 1: a lemezes hiba utn jra kell prblkozni
;
fk_err:	or	a			; CY=0
	ret	z			; visszatrs, ha nem volt hiba
	cp	0A1h			; .NOFIL - utols tallat utn
	jr	nz,fk_er1		; ugrs, ha nem ez a hiba volt
	ld	a,(nbj)
	or	a
	ld	a,0A1h
	ret	nz			; nincs hiba, ha tallt legalbb 1 fjlt (a gykrbe is bekerl a "..") (CY=0)
fk_er1:	cp	0A0h			; .NODIR - lemezcsere trtnhetett vagy kitrltk az adott knyvtrat
	jr	nz,fk_er2		; ugrs, ha nem ez a hiba volt
	call	fk_dout			; aktulis tvonal visszalptetse, legfeljebb a meghajt-listig
	scf				; jra kell prblkozni
	ret
;
fk_er2:	cp	0ADh			; .ABORT - nincs lemez/meghajt, vagy rossz
	jr	nz,fk_er3
	ld	a,(retry_cnt)
	dec	a
	ld	(retry_cnt),a
	scf				; jra kell prblkozni
	ret	nz			; ha lejrt az jraprblkozsok szma: hibakd= 00h
fk_er3:	ld	hl,(path_ptr)		; aktulis tvonal belltsa a meghajt-listra
	ld	(hl),000h
	ld	b,00h			; kirja az A reg.-ben adott hibt, s hibajelzs nlkl tr majd vissza
	or	a			; ZF= 0
	call	nz,fk_er4a		; .ABORT esetn nem r ki semmit
	scf				; jra kell prblkozni -> a meghajt-listt fogja beolvasni
	ret

;
;	Hibakezels fjlmveletek utn
;	in:   A - hibakd
;	out: CY - CY=0 -> jra be kell olvasni a knyvtrat
;	          CY=1 -> elg csak a kpernyt frissteni
;
fk_erff:or	a
	ret	z			; visszatrs, ha nem volt hiba (CY=0)
	cp	092h			; .CTRLC - megszaktottk a parancs vgrehajtst (CLI hibakd)
	scf
	ret	z			; visszatrs, ha ESC volt (CY=1 -> csak frissteni kell a kpernyt)
	cp	089h			; .IPSTR - hibs cl vagy forrs tvonal (CLI hibakd)
	jp	nz,fk_erf0		; ugrs ha nem ez a hiba volt
	ld	hl,erptext		; hibs cl vagy forrs tvonal (nincs hibakd, ZF=1)
	call	fk_er4
	scf				; CY=1
	ret
;
fk_erf0:ld	hl,fuhiba		; lemezes/MOPS hibk kirsa csak hibakddal
	push	af
	call	fk_prn0			; kirs az aktulis karakterpozciba
	pop	af
	ld	l,a
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'
	call	fk_chnk			; bevezet '0'-k levgsa s a szm kirsa
	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	xor	a			; CY=0
	ret

;
;	Hibazenet kirsa
;	in:   A - tnyleges hibakd
;	      B - visszatrskor visszaadand hibakd
;	     HL - hibazenet stringre mutat
;	     ZF - ZF=0 - a hibakdot is kirja az zenet utn
;	out:  A - belpskor B-ben adott hibakd
;
fk_er4a:ld	hl,errtext		; nem dekdolt hiba, kirja a kdjt (ZF=0)
fk_er4:	push	bc
	push	af
	call	fk_msg
	pop	af
	jr	z,fk_er5		; ugrs, ha nem kell a hibakdot kirni
	ld	l,a
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'
	call	fk_chnk			; bevezet '0'-k levgsa s a szm kirsa
fk_er5:	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa		
	call	fk_clsm			; als sor trlse
	call	fk_suml			; sszest sor kirsa
	call	fk_keyinfo		; ideiglenesen: billenty infk kirsa
	pop	af
	or	a			; CY= 0, ZF pedig B reg. belpsi rtktl fgg "fk_er4"-nl
	ret

;
;	Billentyzet-puffer kitakartsa (pergsmentests knyvtrvlts utn)
;	in:     -
;	out:  A - hibakd
;
fk_clnkey:
	ld	e,0FFh			; input krse
	ld	c,006h			; kzvetlen konzol I/O
	call	0005h			; VT-DOS hvsa
	or	a
	jr	nz,fk_clnkey		; ismtls amg van karakter
	ret

;
;	RETURN/JOY tz ellenrzse
;	in:   -
;	out: CY - CY=1 knyvtrvlts trtnt, az j knyvtr tartalmt be kell olvasni
;	     ZF - ZF=1 fjl-kivlaszts trtnt
;
fk_slct:call	fk_aktfadr		; aktulis bejegyzs cme HL-be
	ld	de,11
	add	hl,de
	ld	a,(hl)
	and	10h			; attributum ellenrzse
	jr	nz,slct3		; ugrs, ha nem fjl van kivlasztva
	push	hl
	call	fk_pakt			; fjlnv kimentse a panel adatterletre
	call	fk_pakt
	pop	hl
	dec	hl
	dec	hl
	dec	hl			; HL a fjl kiterjesztsre mutat
	call	fk_exec			; program elindtsa, ha lehetsges
	or	a			; CY= 0
	ret	z			; visszatrs, ha nem volt hiba (ZF= 1)
	ld	hl,erctext
	cp	08Ch			; hibakd: .NORAM - nem elg a memria
	jr	z,slct0
	ld	hl,errtext		; nem dekdolt hiba, kirja a kdjt (ZF=0)
slct0:	ld	b,a			; B= hibakd a visszatrshez
	jp	fk_er4			; ugrs a hiba kirsra
;
slct3:	sbc	hl,de			; knyvtrt vlasztottak, HL a nv elejre mutat
	ld	de,(path_ptr)
	ld	a,(de)
	or	a
	jr	nz,slct4		; ugrs, ha nem a meghajt-listban van, egybknt meghajt root-t llt be
	ld	a,'<'			; A reg.= 'nincs egy meghajt'-t jelz karakter
	sub	(hl)
	jr	z,slct7			; ha korbban nem tallt meghajtt, akkor csak a frisstst jelzi
	ldi				; meghajt betjele
	ldi				; kettspont
	ld	a,92			; '\'
	ld	(de),a
	inc	de
	xor	a
	ld	(de),a			; lezr nulla
	jr	slct7
;
slct4:	ld	a,(hl)			; fjlnv els kt karakternek vizsglata
	cp	'.'			; visszalps egy knyvtrral?
	jr	nz,slct6		; ugrs, ha biztosan nem
	inc	hl
	ld	a,(hl)
	dec	hl
	cp	' '			; ez az aktulis knyvtr jelzse volt?
	jr	nz,slct5
	or	a			; A=32, ZF=0  (NZ), CY= 0
	ret
;
slct5:	cp	'.'
	jr	nz,slct6		; ugrs, ha nem ".."
	call	fk_dout			; visszalps egy knyvtrral
	inc	hl
	ld	de,fnamebuff		; fjlnv puffer cme
	ld	a,b
	ld	bc,0C00h		; max_hossz= 12  spec.kar= 0
	cp	92			; '\'
	jr	z,slct9			; ugrs, ha nem rta fell az els karaktert
	ld	(de),a			; els karakter trolsa
	inc	de
	dec	b			; csak max. 11 karaktert msol
slct9:	call	fk_den2			; elz knyvtrnv msolsa a fjlbufferbe
	jr	slct7b
;
slct6:	call	fk_dent			; tvonal bvtse az alknyvtr nevvel
slct7:	ld	(fnamebuff),a		; kivlasztott fjlnv trlse
slct7b:	scf				; CY= 1	
	ret

;
;	Belps egy alknyvtrba (az aktulis tvonalnv bvtse)
;	in:  HL - az alknyvtr 8+3-as nevre mutat
;	     DE - bvtend tvonal cme (csak fk_den0-nl belpve)
;	out: CY - CY=1 -> nem lpett be
;
fk_dent:ld	de,(path_ptr)		; az aktulis tvonalat bvti
fk_den0:ex	de,hl
	ld	bc,0100h		; max. 256 karakter tvizsglsa (igazbl csak SDC_MAX_PATH-ot kellene)
	xor	a
	cpir				; tvonal-string vgnek megkeresse
	sub	c			; A reg.= sszes karakter a stringben lezr 0-val egytt
	cp	62
	ccf
	ret	c			; visszatrs, ha 61-nl hosszabb a string
	push	hl			; string vge a verembe
	push	af			; stringhossz a verembe
	ex	de,hl
	call	fk_name			; knyvtrnv msolsa a fjlnv pufferbe
	ld	hl,fnamebuff		; fjlnv puffer cme
	ex	de,hl
	sbc	hl,de			; HL= fjlnv hossza
	pop	af			; A reg.= tvonalstring aktulis hossza
	add	a,l			; A reg.= bvts utn vrhat hossz
	pop	hl
	cp	65
	ccf
	ret	c			; visszatrs, ha 64-nl hosszabb lenne a string
	dec	hl			; HL a zrkarakterre mutat
	dec	hl			; utols hasznos karakter
	ld	a,92			; '\'
	cp	(hl)
	jr	z,fk_den1		; ugrs, ha a gykrknyvtrban van (pl. A:\)
	inc	hl
	ld	(hl),a
fk_den1:inc	hl
	ld	de,fnamebuff		; fjlnv puffer cme
	ex	de,hl
	ld	bc,0C00h		; max_hossz= 12  spec.kar= 0
fk_den2:call	fk_scpy			; fjlnv msolsa az tvonalstringbe
	xor	a
	ld	(de),a			; zr nulla bersa, CY=0
	ret

;
;	Visszalps egy knyvtrral (az aktulis tvonalnv visszavgsa az utols '\' jelig)
;	in:  HL - visszalptetend tvonal cme (csak fk_dou0-nl belpve)
;	out:  B - a lezr nulla helyn llt karakter
;	     HL - a visszavgott nv lezr nulljra mutat
;	     ZF - ZF=1 -> a gykrknyvtrban van, B tartalmazza az elz knyvtr kezdbetjt
;
fk_dout:ld	hl,(path_ptr)
fk_dou0:ld	a,(hl)
	or	a
	jr	z,fk_dou1		; ugrs, ha nincs tvonal
	ld	bc,SDC_MAX_PATH		; max. karakter tvizsglsa
	xor	a
	cpir				; tvonal-string vgnek megkeresse
	ld	a,SDC_MAX_PATH-1
	sub	c
	ld	c,a			; BC= tvizsgland karakterek szma (nullnl biztosan nagyobb, ld. belpskori ell.)
	dec	hl			; HL a zrkarakterre mutat
	dec	hl			; HL az utols hasznos karakterre mutat
	ld	a,92			; '\'
	cp	(hl)
	jr	nz,fk_dou2		; ugrs, ha nem a gykrben van
	xor	a
	ld	(hl),a			; '\' trlse a meghajt nv vgrl
	ld	hl,(path_ptr)
	ld	b,(hl)			; trlend karakter mentse B-be
	ld	(hl),a
fk_dou1:inc	a			; ZF= 0
	ret
;
fk_dou2:cpdr				; keress visszafelemenet a '\' jelre
	jp	po,fk_dou3		; ugrs, ha a string elejre rt (=>nem tallt)
	ld	a,':'
	cp	(hl)
	jr	nz,fk_dou3		; ugrs, ha mg nem a gykrknyvtr
	inc	hl			; egybknt meghagyja a visszapert
fk_dou3:inc	hl
	ld	b,(hl)			; trlt karakter mentse B-be
	ld	(hl),000h
	ret
	
;
;	tvonal msolsa a string bufferbe
;	in:  HL - msoland tvonalstring (pathcp0-nl belpve)
;	out:    -
;
pathcpy:ld	hl,(path_ptr)		; aktulis tvonalstring tmsolsa az U0 RAM-ba
pathcp0:ld	de,strbuff
pathcp1:ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	or	a
	jr	nz,pathcp1		; msols a lezr nullig
	ret


fuhiba	.text	"\r\n"
errtext	.text	"Hiba! \000"		; ltalnos hibazenet bevezet rsze
erctext	.text	"Nincs el\221g mem\223ria!\000"
eretext	.text	"Nem futtathat\223 \220llom\220ny!\000"
erptext	.text	"Hat\220rozatlan \226tvonal!\000"	; eredetileg: "A cl vagy forrs tvonala hatrozatlan!"
;
ldtext	.text	"Program bet\224lt\221se...\000"


;
;-----------------------------------------------------
;	Fjlnv-lista elksztse (adott knyvtr beolvassa)
;-----------------------------------------------------
;

;
;	FISH meghvsa
;
;	in:  A - FISH funkcikd
;	    BC,DE,HL,IX - paramterek
;	out: A - hibakd
;	    BC,DE,HL,IX - FISH funkci kimeneti paramterei
;
fk_fish:call	0008h			; FISH funkci vgrehajtsa VT-DOS alatt
	ret


;
; 	Hasznlatlan FCB kitltse
;	in:  DE - kitltend FCB elejre mutat
;	     HL - berand 8+3-as fjlnv
;	out: -
;
fk_fcb:	ex	de,hl			; HL az FCB elejre mutat
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	inc	hl
	ld	b,47			; htralv 47 bjt trlse:
fk_fcb0:ld	(hl),0			;  - keressi attributum = 0 (nem keres ktet azonostt)
	inc	hl			;  - aktulis meghajt = 0
	djnz	fk_fcb0
	ld	bc,-40
	add	hl,bc			; HL visszalltsa a fjlnvre
	ex	de,hl			; HL= 8+3 bjtos fjlnv  DE= FCB-ben fjlnv helye
	ld	bc,11			; 8+3 bjtos fjlnv tmsolsa
	ldir				; a tbbi vltoz nulla
	ret

;	
;	Els illeszked knyvtrbejegyzs keresse (tvonal strbuff-ban)
;	in:  HL - 8+3 (11 karakteres) fjlnvre mutat
;	out:  A - hibakd 
;
fk_frst:ld	de,FCB_1		; FCB1 kitltse hasznlatlan FCB-knt a megadott nvvel
	call	fk_fcb
	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	ld	hl,strbuff		; HL= tvonalnv kezdete
	ld	a,004h			; A = FISH funkci: els keresse
	call	fk_fish			; FISH funkci hvsa
	ret

;	
;	Egy knyvtr fjlneveinek beolvassa
;	in: -
;	out:  A - hibakd
;
fk_dir:	ld	hl,0000h		; fjlok sszestett mretnek nullzsa
	ld	(dircap),hl
	ld	(dircap+2),hl
	xor	a			; tallt fjlok szmnak nullzsa
	ld	(nfiles),a
	ld	hl,(path_ptr)
	cp	(hl)
	jp	z,fk_root		; ha nincs tvonal megadva, akkor a meghajtk listzsa
;
	inc	hl
	inc	hl
	inc	hl
	cp	(hl)			; ha pl. "A:\0" az tvonalnv
	ld	hl,nevtbl		; tallt 20 bjtos nvbejegyzsek kezdete
	jr	nz,fk_d0		; ugrs, ha nincs lezr nulla
	ld	a,'.'			; egy "elz knyvtr" bejegyzs ltrehozsa
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	de,meghtxt+2
	ld	bc,18
	ex	de,hl
	ldir
	ex	de,hl			; HL=kvetkez bejegyzs cme
	ld	a,01			; egy bejegyzs mr van
fk_d0:	ld	(akt_bj),hl
	ld	(nbj),a			; tallati szmll kezd rtke
	call	pathcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	hl,fn_all		; HL a *.*-nak megfelel krdjelekre mutat
	call	fk_frst			; els keresse
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
;
fk_d1:	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= keressi FCB (az els keressbl)
	ld	a,005h			; A = FISH funkci: kvetkez keresse
	call	fk_fish			; FISH funkci hvsa
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli, de valsznleg nincs tbb fjl
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
	jr	nz,fk_d1		; ismtls az sszes bejegyzs megkeressig
	ret				; vagy amg el nem ri a maximlis fjlnv szmot

;
;	Meghajt azonostk listzsa
;	(az els hibs/res meghajt utn nem listz tovbb)
;
fk_root:
	ld	hl,nevtbl		; tallt 20 bjtos nvbejegyzsek kezdete
	ld	(akt_bj),hl
	ld	b,001h			; els meghajtval kezd
root0:	push	bc
	ld	a,003h			; A = FISH funkci: aktulis knyvtr beolvassa
	call	fk_fish			; FISH funkci hvsa
	pop	bc
	or	a
	jr	nz,root1		; ugrs, ha hiba volt
	ld	a,b
	add	a,040h
	ld	de,(akt_bj)		; ide menti a nevet
	ld	(de),a
	ld	a,b
	inc	de
	ld	bc,19			; BC= htralv bjtok a 20-bjtos bejegyzsbl
	ld	hl,meghtxt+1
	ldir				; tbbi adat konstans
	ld	(akt_bj),de		; nvmutat mentse, mr a kv. bejegyzsre mutat
	ld	b,a
	inc	b
	jp	root0			; ugrs a kvetkez meghajt ellenrzsre
root1:	dec	b
	call	z,root2			; korrekci, ha egy meghajtt sem tallt volna
	ld	a,b
	ld	(nbj),a			; tallt meghajtk szma
	xor	a			; ZF=1 - nincs hiba
	ret
;
root2:	ld	de,(akt_bj)		; ide menti a nevet
	ld	bc,3			; <A:> - szveg rsa
	ld	hl,meghtxt-1
	ldir
	ld	a,'>'
	ld	(de),a
	inc	de
	inc	hl
	inc	hl
	ld	c,16
	ldir
	ld	b,1
	ret	
;
fn_all	.db	"???????????"		; fjlnv minden fjlhoz (*.*)
	.db	'<'
meghtxt .db	"A:         "		; meghajtk listzshoz s ".." bejegyzshez a fknyvtrban
	.db	10h			; attributum: alknyvtr
	.dw	0000h			; id
	.dw	0000h			; dtum
	.db	0,0,0,0			; fjlhossz: 0

;
;-----------------------------------------------------
;	Fjlnv-lista kezelse
;-----------------------------------------------------
;

;
;-----------------------------------------------------
;	Fjlnv-lista kezelse: rendezs
;-----------------------------------------------------
;

;
;	Szlknyvtr ellenrzse
;	in:  HL - 20 bjtos bejegyzs cme
;	out: ZF - 1: szlknyvtr, ilyenkor CY=0
;
fk_parent:
	ld	a,'.'
	cp	(hl)
	ret	nz
	inc	hl
	cp	(hl)
	dec	hl
	ret	nz
	push	hl
	inc	hl
	inc	hl
	ld	b,009h			; mg 9 db. SPACE-t ellenriz
	ld	a,020h			; A reg.= SPACE kdja
fk_par0:cp	(hl)
	jr	nz,fk_par1
	inc	hl
	djnz	fk_par0
fk_par1:pop	hl
	ret

;
;	Karakterlncok sszehasonltsa
;	in:   B - sszehasonltand hossz (fk_cmp1-nl belpve)
;	     DE - egyik string cme
;	     HL - msik string cme
;	out: ZF - a kt string megegyezik
;	     CY - 1: a DE mutatta string kisebb  0: a HL mutatta string kisebb
;
fk_cmp:	ld	b,003h
fk_cmp1:ld	a,(de)
	cp	(hl)
	ret	nz
	inc	hl
	inc	de
	djnz	fk_cmp1
	ret

;
;	Fjlbejegyzsek sszehasonltsa
;	in:   C - rendezs szempontja (sorttype)
;	     DE - egyik 20 bjtos bejegyzs cme
;	     HL - msik 20 bjtos bejegyzs cme
;	out: DE - megrzdik
;	     HL - megrzdik
;	     CY - 1: a DE mutatta kisebb  0: a HL mutatta kisebb
;
fk_cext:push	bc
	push	de
	push	hl
	ld	bc,11
	add	hl,bc
	ld	a,(hl)
	and	10h			; knyvtrbit maszkolsa
	ex	de,hl
	add	hl,bc
	ld	c,a
	ld	a,(hl)
	and	10h			; knyvtrbit maszkolsa
	cp	c
	ccf
	pop	hl
	pop	de
	pop	bc
	ret	nz			; visszatrs, ha az egyik knyvtr a msik pedig fjl, a knyvtr a kisebb
	and	10h			; knyvtrbit ellenrzse
	jr	z,cext1			; ugrs, ha mindkett fjl
	call	fk_parent		; HL mutatta nv szlknyvtr jelzs?
	ret	z			; visszatrs, ha igen, CY=0
	ex	de,hl
	call	fk_parent		; DE mutatta nv szlknyvtr jelzs?
	ex	de,hl
	scf
	ret	z			; visszatrs, ha igen, CY=1
	ld	b,8			; 8 karakter sszehasonltsa lesz
cext0:	push	de
	push	hl
	call	fk_cmp1			; (knyvtr)nevek sszehasonltsa
	pop	hl
	pop	de
	ret
;
cext1:	ld	a,c			; rendezsi szempont vizsglata
	and	07Fh
	ld	b,11			; nv szerinti rendezshez 11 karaktert kell sszehasonltani
	dec	a
	jr	z,cext2			; ugrs, ha nv alapjn kell rendezni
	dec	a
	jr	nz,cext5		; ugrs, ha nem kiterjeszts alapjn
	push	de
	push	hl
	ld	a,c
	ld	bc,8
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl			; HL s DE is a fjlnv kiterjesztsekre mutat
	ld	c,a
	call	fk_cmp			; kiterjesztsek sszehasonltsa
	pop	hl
	pop	de
	ld	b,8			; 8 karakter sszehasonltsa lesz
cext2:	call	z,cext0			; fjlnevek sszehasonltsa, ha a kiterjesztsek megegyeznek
	rra				; CY belptetse A reg. 7. bitjre
cext4:	xor	c			; A reg. 7. bitjben CY invertltja, ha ellenkez irny rendezs van
	rla				; eredmnybit vissza CY-be
	ret
;
cext5:	push	bc
	push	de
	push	hl
	ld	bc,12
	dec	a
	jr	nz,cext6		; ugrs, ha dtum alapjn kell rendezni
	ld	c,16
cext6:	ex	de,hl
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ld	a,(de)			; A reg.= DE ltal mutatott dtum/mret als bjtja
	sub	(hl)			; HL mutatta dtum/mret als bjtjnak kivonsa
	ld	c,a
	inc	de
	inc	hl
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	ld	b,a
	inc	de
	inc	hl
	push	bc			; als szavak klnbsge a verembe
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	ld	b,a
	inc	de
	inc	hl
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	rr	c			; CY belptetse C reg. 7. bitjre
	or	b			; eredmny vizsglata, hogy nulla-e
	pop	hl			; HL= als szavak klnbsge
	or	h
	or	l
	ld	a,c
	pop	hl
	pop	de
	pop	bc			; B= 11
	jp	z,cext0			; ha megegyeznek, akkor nv szerint nvekv sorrendben prblja rendezni
	jp	cext4			; ugrs a rendezsi irny ellenrzsre

;
;	Binris keress a rendez bufferben (a buffernek pros cmen kell kezddnie)
;	in:  BC - vizsgland utols elem cme a rendez bufferben -> e
;	     DE - keresend nvre mutat a nvtblzatban
;	out: HL - a nv beszrsi helyre mutat a rendez bufferben
;	     DE - megrzdik
;
fk_find:ld	hl,sortbuff		; HL= els elem cme -> b
find0:	or	a
	sbc	hl,bc
	add	hl,bc
	ret	nc			; visszatrs, ha b >= e
	push	hl			; b verembe
	add	hl,bc			; m=(b+e)/2
	rr	h
	rr	l
	res	0,l
	push	hl			; m verembe
	ld	a,(hl)			; m-hez tartoz elem cme HL-be
	inc	hl
	ld	h,(hl)
	ld	l,a
	push	bc			; e verembe
	ld	a,(sorttype)
	ld	c,a			; rendezsi szempont C-be
	call	fk_cext			; fjlnevek sszehasonltsa
	pop	bc			; rgi e vissza BC-be
	jr	nc,find1		; ugrs, ha a HL mutatta nv a kisebb
	pop	bc			; e= m (rgi e eldobsa)
	pop	hl			; rgi b vissza HL-be
	jr	find0
find1:	pop	hl			; b= m + (1 elem)
	inc	hl
	inc	hl
	pop	af			; rgi b eldobsa
	jr	find0

;
;	Fjlnevek rendezse
;
fk_sort:ld	hl,sortbuff		; HL= rendezpuffer cme
	ld	de,nevtbl		; DE= tallt 20 bjtos nvbejegyzsek kezdete
	ld	a,(nbj)			; A reg.= tallt bejegyzsek szma
	or	a
	ret	z			; visszatrs, ha nincs egy bejegyzs sem
	push	af
	push	hl
sort0:	ld	(hl),e			; nv cme a rendez-pufferbe
	inc	hl
	ld	(hl),d
	pop	hl
	inc	hl
	inc	hl
	pop	af
	dec	a
	ret	z			; visszatrs, ha nincs tbb bejegyzs
	push	af
	push	hl
	ld	b,h
	ld	c,l
	ex	de,hl
	ld	de,20
	add	hl,de			; HL a kvetkez fjlnvre mutat
	push	hl
	ex	de,hl
	call	fk_find			; nv beszrsi helynek megkeresse
	pop	de
	ld	b,h			; BC= beszrsi cm
	ld	c,l
	pop	hl			; HL= utols, mr szabad bejegyzs cme
	push	hl
	push	hl
	sbc	hl,bc
	ld	b,h
	ld	c,l
	pop	hl
	jr	z,sort1			; ugrs, ha nem kell mozgatni az adatokat
	push	de
	ld	d,h
	ld	e,l
	inc	de
	dec	hl
	lddr
	pop	de
	inc	hl
sort1:	jp	sort0			; ugrs a rendez-pufferbe rsra, majd ismtls minden bejegyzsre

;
;	Rendez-buffer aktulis index elembl fjlnvcm kiolvassa
;
fk_aktfadr:
	ld	a,(xaktbj)

;
;	Rendez-buffer adott index elembl fjlnvcm kiolvassa
;	in:    A - index
;	out:  HL - 20-bjtos fjlnvbejegyzs kezdcme
;
fk_fad0:ld	de,sortbuff
	ld	l,a
	ld	h,000h
	add	hl,hl			; HL= 2* index
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	(akt_bj),hl		; cm trolsa a vltozban is
	ret

;
;	Wrapper funkci kls modulokhoz
;
fk_fadr:call	fk_fad0
	ret
	
;
;	Fjlnv keresse a rendez bufferben
;	in:   -
;	out:  A - index
;
fk_ffnv:ld	hl,strbuff		; keresend fjlnv helynek kitltse SPACE karakterekkel
	ld	b,11
ffnv0:	ld	(hl),020h
	inc	hl
	djnz	ffnv0
	ld	bc,0C2Eh		; max_hossz= 12  spec.kar= '.'
	ld	hl,fnamebuff
	ld	a,(hl)
	or	a
	ret	z			; visszatrs, ha nincs megadva fjlnv (index = 0)
	ld	de,strbuff
	call	fk_scpy			; fjlnv msolsa a string bufferbe
	inc	hl			; HL a kiterjesztsre mutat
	ld	de,strbuff+8		; DE= cl
	ld	bc,0300h		; max_hossz= 3  spec.kar= 00h
	call	nc,fk_scpy		; kiterjeszts msolsa, ha volt specilis karakter ('.')
	ld	a,(nbj)
	or	a
	ret	z			; vge, ha egy bejegyzs sincs (index = 0)
	ld	b,a			; B= bejegyzsek szma
	ld	hl,sortbuff		; a rendez buffer 0. elemvel kezd
ffnv1:	push	bc
	ld	e,(hl)			; fjlnvcm kiolvassa
	inc	hl
	ld	d,(hl)
	inc	hl
	push	hl
	ld	hl,strbuff
	ld	b,11			; max. 11 karaktert vizsgl
	call	fk_cmp1			; fjlnevek sszehasonltsa
	pop	hl
	pop	bc
	jr	z,ffnv2			; ugrs, ha megtallta
	djnz	ffnv1			; ismtls az sszes bejegyzsig
	xor	a
	ret				; visszatrs, ha nem tallt bejegyzst (index = 0)
ffnv2:	ld	a,(nbj)			; index szmtsa
	sub	b
	ret
	
;
;	Tallt knyvtr-bejegyzsek kirsa a rendez buffer alapjn
;	in:  A - aktulis bejegyzs indexe
;	out:   -
;
fk_dspl:ld	(xaktbj),a
	ld	e,000h			; E= kirs kezd indexe
	ld	b,IY_MAXLN		; B= maximlisan kirhat sorok szma
	ld	c,b
	dec	c			; C= maximlisan kirhat sorok szma - 3
	dec	c
	dec	c
	sub	c
	jr	c,dspl0			; ugrs, ha az aktulis bejegyzs eltt nincs C mennyisg bejegyzs
	ld	e,a
dspl0:	ld	a,e
	add	a,b
	ld	c,a			; C= kezd index + max. sorok szma
	ld	a,(nbj)
	ld	d,a			; D= bejegyzsek szma
	or	a
	ret	z			; vge, ha egy bejegyzs sincs
	sub	c			; a tallt bejegyzsek szma a max. kirand indexnl kisebb?
	jr	nc,dspl2		; ugrs, ha nem
	add	a,e			; kezd index mdostsa a klnbsggel
	jr	c,dspl1
	xor	a			; ha 0-nl kisebb lenne, akkor fixen 0-ra lltja
dspl1:	ld	e,a
	ld	a,d			; az utols bejegyzs s a kezd index kztti klnbsg szmtsa
	sub	e
	ld	b,a			; a htralv sszes bejegyzs kirsa
dspl2:	ld	c,IY_FSTLN		; C= az els sor szma
	ld	a,(xaktbj)
	sub	e
	add	a,c
	ld	(akt_ln),a		; aktulis kpernysor
	ld	hl,sortbuff		; HL a rendez buffer elejre mutat
	ld	d,000h
	add	hl,de			; eltols a kezd index-el
	add	hl,de
dspl3:	push	bc			; C = akt. sor (Y koordinta)
	ld	e,(hl)			; fjlnvcm kiolvassa
	inc	hl
	ld	d,(hl)
	inc	hl
	push	hl
	ex	de,hl
	call	fk_fnir			; formzott fjlnv kirsa
	pop	hl
	pop	bc
	inc	c			; kvetkez sor
	djnz	dspl3			; ismtls az sszes sor vgig
	ret

;
;	Szveg msolsa a specilis karakterig vagy a lezr nullig
;	in:   B - maximlis hossz
;	      C - specilis karakter
;	     DE - cl
;	     HL - specilis karakterrel lezrt forrs
;	out: DE - utols karakter utn mutat
;	     HL - a specilis karakterre mutat (ha CY=0)
;	     CY - CY=0 elrte a specilis karaktert  CY=1 a maximlis hosszig vagy a nullig msolt
;
fk_scpy:ld	a,(hl)
	cp	c
	ret	z
	or	a
	scf
	ret	z
	ld	(de),a
	inc	de
	inc	hl
	djnz	fk_scpy
	ret

;
;	Fjlnv kirsi formtumnak elksztse a fjlnv pufferbe (fjlnv.kit formtumban)
;	in:  HL - 8+3-as fjlnv cme nvtblzat bufferben
;	out: DE - az elksztett string lezr nulla karakterre mutat
;
fk_name_bj:

;
;	Fjlnv kirsi formtumnak elksztse a fjlnv pufferbe (fjlnv.kit formtumban)
;	in:  DE - cl cme (fk_nam0 -nl belpve, egybknt a fjlnv pufferbe kerl)
;	     HL - 8+3-as fjlnv cme
;	out: DE - az elksztett string lezr nulla karakterre mutat
;
fk_name:ld	de,fnamebuff		; cl puffer cme
fk_nam0:ld	bc,0820h		; max_hossz=8 spec.kar=32
	push	hl
	call	fk_scpy			; fjlnv msolsa
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	bc,0008
	pop	hl
	add	hl,bc
	ld	bc,0320h		; max_hossz=3 spec.kar=32
	call	fk_scpy			; kiterjeszts msolsa
	ld	a,003h
	cp	b
	jr	nz,fk_nam1		; ugrs, ha legalbb egy karaktert msolt
	dec	de			; egybknt visszalps a '.' karakterre
fk_nam1:xor	a
	ld	(de),a
	ret


;
;-----------------------------------------------------
;	Bels formtum fjladatok kezelse
;-----------------------------------------------------
;

;
;	Egy 20 bjtos nvbejegyzs elksztse az adott FCB alapjn
;	in:  HL - FCB cme
;	out:  A - A=0 s ZF=1 -> elrte a max. trolhat bejegyzst
;	     DE - a ltrehozott struktra mg mutat:
;	          0..10   fjlnv (8+3)
;	          11      attributum
;	          12,13   mdosts ideje
;	          14,15   mdosts dtuma
;	          16..19  fjl hossza bjtban
;
fk_mnev:ld	a,0FEh
	cp	(hl)
	ret	nz			; vissza, ha nem meghatrozott FCB
	ld	bc,8
	add	hl,bc			; HL a fjlnvre mutat az FCB-n bell
	ld	a,(hl)
	cp	'.'
	jr	nz,mnev0
	inc	hl
	ld	a,(hl)
	dec	hl
	cp	' '			; ez az aktulis knyvtr jelzse lehet?
	jr	nz,mnev0
	ld	c,11
	add	hl,bc			; az attribtumot is ellenrizni kell
	ld	a,(hl)
	sbc	hl,bc
	and	10h
	ret	nz			; visszatr, ha tnyleg az
mnev0:	ex	de,hl
	ld	hl,(akt_bj)		; ide menti a nevet
	ld	c,20
	add	hl,bc			; HL= kvetkez bejegyzs cme
	ld	(akt_bj),hl
	sbc	hl,bc
	ex	de,hl
	ld	c,11			; 8+3 fjlnv
	ldir
	ld	a,(hl)			; A reg.= attribtum
	and	07Fh			; 7. bit trlse, ez a kivlasztottsgot fogja jellni
	ld	(de),a
	inc	de
	ld	c,11
	add	hl,bc			; HL az id-adatokra mutat
	ld	c,4			; 2 bjtos id + 2 bjtos dtum
	ldir
	inc	hl
	inc	hl
	ld	c,4			; 4 bjtos fjlhossz
	ldir
	and	10h			; knyvtr-bit ellenrzse
	jr	nz,mnev1
	dec	hl			; ha nem alknyvtr, a fjlmret hozzadsa az eddigi sszeghez
	ld	b,(hl)
	dec	hl
	ld	c,(hl)
	dec	hl
	ld	d,(hl)
	dec	hl
	ld	e,(hl)
	ld	hl,(dircap)
	add	hl,de
	ld	(dircap),hl
	ld	hl,(dircap+2)
	adc	hl,bc
	ld	(dircap+2),hl
	ld	a,(nfiles)
	inc	a			; tallt fjlok szmnak nvelse
	ld	(nfiles),a
mnev1:	ld	a,(nbj)
	inc	a			; tallt bejegyzsek szmnak nvelse
	ld	(nbj),a
	sub	nbj_max			; ha ZF=1, elrte a max. trolhat bejegyzst
	ret

;
;	Kirand karakterek msolsa ellenrzssel
;	in:   B - msoland hossz
;	     DE - clterlet kezdete
;	     HL - msoland string kezdete
;	out:  B - 000h
;	     DE - az tmsolt cl string utnra mutat
;	     HL - az tmsolt forrs string utnra mutat
;
fk_ncpy:ld	a,(hl)
	inc	hl
	cp	020h
	jr	c,fk_ncp0
	cp	0E0h
	jr	c,fk_ncp1
fk_ncp0:ld	a,020h
fk_ncp1:ld	(de),a
	inc	de
	djnz	fk_ncpy
	ret

;
;	Egy knyvtrbejegyzs kirsi formtumnak elksztse
;	in:  HL - nv 20 bjtos bejegyzsnek kezdete
;	out:  A - attribtum bjt, a 7. bit a kivlasztottsgot jelzi
;            BC - formzott hossz
;
fk_fnev:ld	de,strbuff
	ld	b,008h			; fjlnv msolsa
	call	fk_ncpy
	ld	a,020h			; 2 db. SPACE a nv s kiterjeszts kz
	ld	(de),a
	inc	de
	ld	(de),a
	inc	de
	ld	b,003h			; kiterjeszts msolsa
	call	fk_ncpy
	push	hl			; az attributum cmnek mentse
	ld	a,020h
	ld	(de),a
	inc	de
	ld	a,004h			; kurzor jobbra (res karakter)
	ld	(de),a
	inc	de
	ld	a,(hl)			; attributum elemzse
	and	10h			; alknyvtr ?
	jr	z,fnev0
	ld	hl,dirtxt
	ld	bc,11
	ldir
	jr	fnev1	
fnev0:	ld	bc,8
	add	hl,bc			; HL a fjlhosszra mutat
	call	fk_ascc			; fjlhossz kirsa
	ld	a,020h
	ld	(de),a
	inc	de
fnev1:	pop	hl
	ld	bc,26			; BC= szveg hossza (visszatrsi rtknek) (13+2+10+1)
	ld	a,IY_NCLMS		; megjelentend oszlopszm A reg.-be
	cp	003h
	ld	a,(hl)			; attribtum bjt A reg.-be visszatrshez
	ret	z			; visszatrs, ha csak 3 oszlop kell (4 szn md)
	push	hl
	ld	bc,4
	add	hl,bc			; HL a dtum bjtokra mutat
	call	fk_date
	ld	a,32
	ld	(de),a
	inc	de
	pop	hl
	inc	hl
	inc	hl			; HL az id bjtokra mutat
	call	fk_time
	ld	a,32
	ld	(de),a
	inc	de
	ld	c,(hl)			; C reg.= attributum
	ld	a,'r'
	bit	0,c			; READ ONLY bit
	jr	nz,fnatr
	ld	a,32
fnatr:	ld	(de),a
	inc	de
	ld	a,'a'
	bit	5,c			; ARCHIVE bit
	jr	nz,fnata
	ld	a,32
fnata:	ld	(de),a
	inc	de
	ld	a,'h'
	bit	1,c			; HIDDEN bit
	jr	nz,fnath
	ld	a,32
fnath:	ld	(de),a
	inc	de
	ld	a,'s'
	bit	2,c			; SYSTEM bit
	jr	nz,fnats
	ld	a,32
fnats:	ld	(de),a
	inc	de
	ld	a,c
	ld	bc,47			; BC= szveg hossza (visszatrsi rtknek) (13+2+10+1+10+1+5+1+4)
	ret

;
dirtxt	.text	"   <dir>   "		; alknyvtr nevnek kirshoz
;


;
;-----------------------------------------------------
;	Kperny-megjelent rutinok
;-----------------------------------------------------
;

;
;	Szveg kirsa adott karakteres pozciba az IOMEM terletrl
;	in:   B - X poz. (ha 0 az X pozci az aktulis marad)
;	      C - Y poz. (ha 0 az Y pozci az aktulis marad)
;	     HL - 0-val lezrt string
;	out: HL - a lezr nulla utni cm
;
fk_prn0:ld	bc,0000h		; vltozatlan pozci
fk_prnt:call	ed_cpos			; kurzor-pozcionls
	ld	de,strbuff		; szveg tmsolsa az U0 RAM-ba
fk_prn1:ld	a,(hl)
	ldi
	or	a
	jr	nz,fk_prn1
	scf				; -1 a hosszbl a lezr nulla miatt
fk_prn2:push	hl			; lezr nulla utni cm a verembe
	ex	de,hl
	ld	de,strbuff
	sbc	hl,de			; stringhossz szmtsa
	jr	z,fk_prn3
	ld	b,h
	ld	c,l
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa
fk_prn3:pop	hl			; lezr nulla utni cm HL-be
	ret

;
;	Adott karakterek levgsa a szveg elejrl, majd kirs
;	in:  A - levgand karakter (pl. SPACE, '0')
;	    DE - szveg utols karaktere utni cmre mutat "strbuff"-ban
;
fk_chnk:ld	c,a
	ex	de,hl			; HL= string vge
	ld	(hl),000h		; lezr nulla elhelyezse
	ld	de,strbuff
chnk0:	ld	a,(de)
	or	a
	jr	z,chnk1			; az utols karaktert mindenkpp kirja
	inc	de
	cp	c
	jr	z,chnk0
chnk1:	dec	de
	or	a
	sbc	hl,de
	ld	c,l
	ld	b,h
	call	ed_bkout		; szveg kirsa
	ret

;
;	Karakteres sor s oszlop rtkbl vidememria-cm kiszmtsa
;	in:   A - sor szma (1..24)
;	      C - oszlop szma (0..63)
;	out:  A - memrialapozsi rtk
;	     BC - megrzdik
;	     DE - megrzdik
;	     HL - karakteres pozci bal fels bjtjnak cme a memriban
;
fk_vid:	dec	a			; sorszm 0..23 kz igaztva
	ld	h,a			; szmols: sorszm * 10 tv sor * 64 bjt/tv sor
	add	a,a			; A reg.= sorszm * 4
	add	a,a
	add	a,h			; A reg.= sorszm * 5
	ld	h,a
	xor	a
	srl	h			; H:A= sorszm * 5 * 128 = sorszm * 640
	rra
	add	a,c			; kezd oszlopcm hozzadsa
	ld	l,a			; (itt nem lehet tvitel, mert A reg. als 7 bitje nulla)
	set	7,h			; vidememria offszet (08000h) hozzadsa
	ld	a,VID_PAGE_CFG		; A reg.= U0, U1, VID, CART
	ret

;
;	Legals sor trlse
;
fk_clsm:ld	a,INFO_LN		; als sor koordintja

;
;	Egy szveges sor trlse (csak a vidememriban)
;	in:  A - sor szma (1..24)
;	     C - kezd oszlop (0..63)   (fk_cln0 -nl belpve)
;	     D - kitlt bjt           (fk_cln0 -nl belpve)
;	     E - trlend hossz (1..64) (fk_cln0 -nl belpve)
;
fk_cln:	ld	c,000h			; C= kezd oszlop
	ld	e,040h			; E= trlend hossz
	ld	d,IY_CLRFILL
fk_cln0:call	fk_vid			; vide-cm szmtsa
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,64			; a teljes sorhossz 64 karakter
	sub	e
	ld	c,a			; C= soremelsi rtk
	ld	a,10			; a szveges sor 10 tv sorbl ll
fk_cln1:ld	b,e			; B= trlend hossz
fk_cln2:ld	(hl),d			; egy sor trlse
	inc	hl
	djnz	fk_cln2
	add	hl,bc			; HL a kvetkez sor elejre mutat
	dec	a
	jr	nz,fk_cln1		; ismtls mind a 10 tv sorra
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a
	ei
	ret

;
;	Invertls kezdeti oszloppozcija
;	in:  -
;	out:  A - megrzdik
;	      C - kezd oszlop pozci
;
fk_istr:ld	c,IY_INVSTART

;
;	Oszloppozci korriglsa
;	in:   C - oszlop pozci
;	out:  A - megrzdik
;	      C - korriglt oszlop pozci
;
fk_corr:push	af
	ld	a,(namecl_offs)
	add	a,c
	ld	c,a			; kezd oszlop pozci
	pop	af
	ret

;
;	Egy szveges sor inverz megjelentse
;	in:  A - sor szma (1..24)
;	     C - kezd oszlop (0..63) (fk_lin4 -nl belpve)
;	     D - az egy sorban lv invertland karakterek szma (fk_lin4 -nl belpve)
;
fk_linv:ld	d,IY_INVFULL		; a teljes sor invertlsa
	call	fk_istr			; kezd oszlop pozci
fk_lin4:ld	b,0FFh			; B= vezrl bjt, ha nem 0, akkor mindenkpp invertl, egybknt csak visszainvertl
fk_lin5:ld	e,10			; egy szveges sor 10 kppont magas
	call	fk_vid			; vide-cm szmtsa
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,(hl)			; karakteres pozci bal fels bjt vizsglata
	and	0CCh			; a 4-szn md miatt csak a kt balszls pixelt vizsglja (ott a kijells az els betnl kezddik)
	or	b
	jr	z,linv2			; ha csak visszainvertlni kell s 000h a bjt, akkor ugrs a befejezsre
	ld	a,64			; a teljes sorhossz 64 karakter
	sub	d
	ld	c,a			; C= a sor vgn nem invertland bjtok
linv0:	ld	b,d			; az invertland sorhossz B-be
linv1:	ld	a,(hl)
	cpl				; 2-szn mdban egyszeren csak komplementlni kell
	ld	(hl),a			; a kpbjtot
	inc	hl
	djnz	linv1
	add	hl,bc			; HL a kvetkez sor elejre mutat
	dec	e
	jr	nz,linv0
linv2:	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret

;
;	Kperny scroll-ozsa
;	in:  -
;	out: -
;
fk_scup:di
	call	fk_istr			; kezd oszlop pozci
	ld	a,IY_FSTLN		; az els sor bal fels bjtja lesz a clcm
	call	fk_vid			; cm szmtsa
	out	(002h),a		; memrialapozs belltsa
	ld	a,002h			; A reg. = karakter sor offszet -> 640
	ld	de,64			; DE = TV sor lptetsi rtke -> 64
	jr	fk_sc0			; ugrs a sorok msolsra
;
fk_scdw:di
	call	fk_istr			; kezd oszlop pozci
	ld	a,IY_LSTLN		; az utols karakter sor legals TV sora lesz a clcm
	inc	a
	call	fk_vid			; cm szmtsa
	out	(002h),a		; memrialapozs belltsa
	ld	a,0FDh			; A reg. = karakter sor offszet -> -640
	ld	de,-64			; DE = TV sor lptetsi rtke -> -64
	add	hl,de			; HL az utols sor aljra mutat
;
fk_sc0:	ld	b,IY_SCLNS		; B  = msoland TV sorok szma
	ld	c,IY_INVFULL		; C  = egy msolt sor hossza
fk_sc1:	push	bc
	push	de			; TV sor lptets rtke a verembe (64 v. -64)
	push	hl
	ex	de,hl			; DE = clcm
	ld	h,a			; HL = 640 v. -640
	ld	l,080h
	add	hl,de			; HL = forrscm
	ld	b,000h
	ldir				; egy sor msolsa
	pop	hl
	pop	de
	add	hl,de
	pop	bc
	djnz	fk_sc1
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret


;
;	Egy oszlopfejlc kirsa
;	in:   C - sorkezdet eltolsa
;	     HL - a kirand oszlop adataira mutat
;	out: HL - a kvetkez oszlop adataira mutat
;
fk_hsr:	ld	a,c			; A reg.= sorkezdet eltolsa
	add	a,(hl)			; relatv oszlopkoordinta hozzadsa
	inc	hl
	ld	b,a
	ld	c,IY_HEADLN
	call	ed_cpos			; sugr-pozicionls karakteres pozciba
	ld	a,(sorttype)
	bit	7,a
	ld	c,05Eh			; '^' - nvekv sorrend jelzsre
	jr	z,fk_hs0
	ld	c,'v'			; 'v' - cskken sorrend jelzsre
fk_hs0:	and	07Fh
	cp	(hl)
	jr	z,fk_hs1
	ld	c,020h			; SPACE kirsa, ha nem az aktulis oszlop szerint van rendezve
fk_hs1:	call	ed_chout
	inc	hl
	ld	b,000h			; BC= kirand karakterek szma
	ld	c,(hl)
	inc	hl
	push	bc
	ld	de,strbuff		; szveg tmsolsa a string bufferbe
	ldir				; msols utn HL mr a kvetkez fejlc adataira mutat
	pop	bc
	ld	de,strbuff		; DE= szveg kezdcme
	call	ed_bkout		; fejlc-szveg kirsa
	ret
	
;
;	Oszlopfejlcek megjelentse
;	in:  -
;	out: -
;
fk_head:ld	a,9			; csak 9 sor lesz egy karakter
	ld	(charlines),a
	ld	b,IY_NCLMS		; B= kirand oszlopok szma
	ld	a,(namecl_offs)
	add	a,IY_NAMECL
	ld	c,a			; C= sorkezdet eltolsa
	ld	hl,fk_fejtxt		; HL az els oszlop-szveg kezdcmre mutat
fk_hed1:push	bc
	call	fk_hsr			; fejlcek kirsa
	pop	bc
	djnz	fk_hed1
	ld	a,(namecl_offs)
	add	a,IY_PNUMCL
	ld	b,a			; B= panelsorszm X pozcija
	ld	c,IY_HEADLN		; C= fejlc sor Y
	call	ed_cpos			; sugr-pozicionls karakteres pozciba
	ld	c,'#'			; aktulis panelsorszm kirsa
	call	ed_chout
	ld	a,(akt_panel)
	add	a,'1'
	ld	c,a
	call	ed_chout
	ld	a,10			; karakter sormagassg visszalltsa
	ld	(charlines),a
	ret

;
;	Oszlopfejlcek adatai
;	(X koordinta, rendezsi sorrend-azonost, szveg hossza, fejlc szvege)
;
fk_fejtxt:
	.db	COL_NEV, SORT_NEV, 003h
	.text	"N\221v"		; Nv
	.db	COL_KIT, SORT_KIT, 004h
	.text	"Kit."			; Kiterjeszts
	.db	COL_MERET, SORT_MERET, 005h
	.text	"M\221ret"		; Mret
	.db	COL_DATUM, SORT_DATUM, 005h
	.text	"D\220tum"		; Dtum
	.db	COL_ATTR, SORT_ATTR, 005h
	.text	"Attr."			; Attribtumok

;
;kjltxt	.text	"Kijel\224lve: \000"	; Kijellve:
bajtxt	.text	" / "			; /
filtxt	.text	" f\220jl\000"		; fjl
;
;
;	sszest sor megjelentse
;
fk_suml:call	fk_ms1			; INK s PAPER belltsa
	ld	a,(namecl_offs)		; nv kezd oszlopnak offszet rtke (kt paneles megjelentshez)
	add	a,002h
	ld	b,a			; X poz.= 2
	ld	c,IY_SUMLN		; y poz.= als sor
;	ld	a,(nselect)		; A reg.= kijellt fjlok szma
;	or	a			; vannak kijellt fjlok?
;	jr	z,suml0			; ugrs, ha nem
;	jr	suml0			; !!! kijelltek sszegzse tl lass, ezrt van kivve
;	dec	b			; X poz.= 1
;	ld	hl,kjltxt		; "Kijellve: "
;	call	fk_prnt
;	ld	a,(nselect)		; A reg.= kijellt fjlok szma
;	ld	hl,selcap+3		; kijellt fjlok sszmretre mutat
;	jr	suml1
suml0:	call	ed_cpos			; kurzor-pozicionls
	ld	a,(nfiles)		; A reg.= fjlok szma a knyvtrban (max. 99)
	ld	hl,dircap+3		; sszestett fjlmret a string-bufferbe
suml1:	push	af			; fjlok szma a verembe
	ld	b,(hl)
	dec	hl
	ld	d,(hl)
	dec	hl
	ld	e,(hl)
	ex	de,hl
	xor	a
	srl	b			; B:HL osztsa 2-vel -> fjlmret 512 bjtban
	rr	h
	rr	l
	ld	de,strbuff
	call	fk_fre3			; 512 bjtos egysgek kirsa kB-ban
	ld	hl,bajtxt		; " / "
	ld	c,3
	ldir
	call	fk_chnk			; bevezet SPACE karakterek levgsa s kirs a kpernyre
	pop	af			; A reg.= (kijellt) fjlok szma
	ld	l,a			; fjlok szma HL-be
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'			; bevezet '0' karakterek levgsa
	call	fk_chnk
	ld	hl,filtxt		; " fjl"
	call	fk_prn0
	ret

sugtxt	.text	"S\226g\223\000"	; Sg
;
;
;	Billenty informcis sor megjelentse
;
fk_keyinfo:
	call	fk_ms1			; INK s PAPER belltsa
	ld	hl,sugtxt		; "Sg"
	ld	bc,03700h + INFO_LN	; X poz.= 55  y poz.= 24
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h
	jr	z,fk_kin0		; ugrs, ha 2-szn md
	ld	b,28			; X poz.= 28
fk_kin0:push	af
	call	fk_prnt			; szveg kirsa
	pop	de
	inc	d			; D - invertland bjtok szma
	ld	c,54			; C - kezd oszlop
	ld	a,INFO_LN		; A reg. - sor szma
	jp	fk_lin4			; "S" bet inverz megjelentse, majd visszatrs

;
;	Egy knyvtrbejegyzs kirsa
;	in:   C - Y poz. (ha 0 az Y pozci az aktulis marad)
;	     HL - nv 20 bjtos bejegyzsnek kezdete
;	out:    -
;
fk_fnir:ld	a,(namecl_offs)		; nv kezd oszlopnak offszet rtke (kt paneles megjelentshez)
	add	a,IY_NAMECL
	ld	b,a			; B = X poz.  C = Y poz.
	push	bc			; koordintk mentse
	call	ed_cpos			; kurzor pozicionlsa
	call	fk_fnev			; formzott fjlnv elksztse
	pop	hl
	ld	h,a
	push	hl			; attribtum bjt s sorpozci mentse
	and	10h			; alknyvtr ?
	jr	z,fk_fni0		; ugrs, ha nem
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
fk_fni0:inc	a
	ld	d,a			; INK belltsa (2-szn mdban s fjloknl 1, 4-sznnl knyvtr esetn 2)
	ld	e,000h			; PAPER= 0
	call	ed_setcolors
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa: formzott fjlnv
	ld	de,00100h		; INK= 1 PAPER= 0
	call	ed_setcolors
	pop	hl
	ld	a,l
;
;	Bejegyzs inverz megjelentse, ha ki van jellve
;	in:  A - sor szma (1..24)
;	     H - 7.bit = 1 -> ki van vlasztva
;
fk_fninv:
	bit	7,h
	ret	z			; visszatrs, ha nincs kivlasztva a fjl
fk_fninv0:
	ld	b,0FFh			; B= vezrl bjt, 0FFh -> mindenkpp invertl
fk_fndesel:
	ld	c,IY_SELSTART		; kezd oszlop pozci
	call	fk_corr			; oszlop rtk korriglsa a panel pozicija szerint
	ld	d,IY_SELCH		; D= az els 45 karakter a sorban
	jp	fk_lin5			; sor inverz megjelentse, majd visszatrs

;
;	zenet kirsa a legals sorba
;	in:  HL - nullval lezrt string cme
;	out:    -
;
fk_ms0:	push	hl		
	call	fk_clsm			; als sor trlse
	pop	hl
	ld	b,001h			; X poz.= 1
	ld	c,INFO_LN		; y poz.= als sor
fk_ms1:	ld	d,IY_INK		; INK belltsa
	ld	e,IY_PAPER		; PAPER belltsa
	call	ed_setcolors		; INK s PAPER belltsa
	ret
;
fk_msg:	call	fk_ms0
	jp	fk_prnt			; zenet kirsa a kperny aljra

;
;	zenet kirsa a legals sorba (fjlmanipulcis funkcikhoz)
;	in:  HL - nullval lezrt string cme az "sdc_util.asm" modulban
;	out:  L - aktulis grafikusmd (0-> 2 szn  1-> 4 szn)
;
fk_pmsg:call	fk_ms0			; zenetsor trlse, betszn belltsa
;
	CALL_UT_PRN0			; zenet kirsa a kperny aljra
;
	ld	l,IY_GRMODE		; grafikusmd L-be
	ret


;
;-----------------------------------------------------
;	Httr s kezdkperny megjelentse
;-----------------------------------------------------
;

;
;	tvonal s zenet sor trlse 4 szn mdban
;	in:  HL - a keret bal fels sarknak memriacme
;	out: -
;
fk_filn:res	7,h			; a vide memria kezdcmnek kivonsa a keret kezdcmbl
	ld	b,h			; az gy kiszmolt hossz rtk BC-be
	ld	c,l
	ld	hl,08000h		; HL a vidememria elejre mutat
	ld	de,08001h		; DE= HL + 1
	ld	a,IY_CLRFILL		; A reg.= kitlt bjt rtke
	ld	(hl),a
	ldir				; sorok kitltse az tvonal nv helyn
;
	ld	hl,08000h + ((lst_ln +1) * 640)
	ld	d,h			; HL = keret alatti sor ketdete
	ld	e,l
	inc	de
	ld	(hl),a			; BC = kitltend memriaterlet mrete a kperny aljig
	ld	bc,((23 - lst_ln) * 640)-1
	ldir				; sorok kitltse az zenet sor helyn
	ret

;
;	Ngyszgletes keret rajzolsa 4 szn mdban
;	in:  HL - a keret bal fels sarknak memriacme
;	out:  B - 00h
;
fk_bold:call	fk_bol2			; keret fels oldalnak rajzolsa
	ld	b,(lst_ln - fst_ln +2) * 10 + 2
	ld	de,63			; B  = sorok szma  DE = kt oldal kztti tvolsg
fk_bol1:ld	(hl),008h		; bal oldali keret
	add	hl,de
	ld	(hl),001h		; jobb oldali keret
	inc	hl
	djnz	fk_bol1
fk_bol2:ld	b,64			; keret als oldala
fk_bol3:ld	(hl),00Fh
	inc	hl
	djnz	fk_bol3
	ret

;
;	Ngyszgletes keret rajzolsa 2 szn mdban
;	in:   A - keret szlessge -1 (31 v. 63)
;	     HL - a keret bal fels sarknak memriacme
;	out:  A - megrzdik
;	      B - 00h
;
fk_kpan:push	hl
	call	fk_kpa3			; keret fels oldalnak rajzolsa
;
	ld	de,33 + (5 * 64) + 17	; DE = offszet rtk, ha 32 bjt szles keretet kell rajzolni
	add	hl,de			; HL a fggleges elvlaszt vonal oszlopra mutat
	ld	de,64			; DE = soremels rtke
	cp	31
	jr	nz,fk_kpa1		; ugrs, ha nem 32 bjt szles keret kell (A reg. = 63)
	ld	b,195			; B  = sorok szma
fk_kpa0:ld	(hl),008h		; elvlaszt fggleges vonal (a bjton belli pozci vltoztathat!)
	add	hl,de
	djnz	fk_kpa0
;
fk_kpa1:pop	hl
	add	hl,de			; HL = fels keret alatti sor eleje
	push	hl
	ld	b,a
	ld	a,e			; A reg. = 64
	sub	b
	ld	c,a			; C = 64 - A reg.  (33 v. 1)
	ld	a,b
	ld	b,218			; B = sorok szma
fk_kpa2:ld	(hl),0C0h		; bal oldali keret
	ld	e,a
	add	hl,de
	ld	(hl),00Ch		; jobb oldali keret
	ld	e,c
	add	hl,de
	djnz	fk_kpa2
	call	fk_kpa3			; keret als oldalnak rajzolsa
	pop	hl
	cp	31
	ret	nz			; visszatrs, ha nem 32 bjt szles keret kell
	ld	de,200 * 64
	add	hl,de			; HL = llapotsor vzszintes elvlaszt vonalnak kezdete
fk_kpa3:ld	b,a			; vzszintes vonal rajzolsa faltl falig
fk_kpa4:ld	(hl),0FFh
	inc	hl
	djnz	fk_kpa4
	ld	(hl),0FCh
	ret

;
;	Sarokrszek rajzolsa
;	in:  DE - a keret adatbjtjaira mutat
;	     HL - bal fels kezdpozci
;	out: HL - a kirajzols utni sor bal szle
;	     DE - az utols adatbjt utnra mutat
;
fk_sark:ld	a,(de)
	inc	de
	or	a
	ret	z
fk_sar0:ex	de,hl
	ldi
	ex	de,hl
	ld	bc,63
	add	hl,bc
	dec	a
	jr	nz,fk_sar0
	ret

;
;	Fejlc sznezse
;	in:   B - egy fejlc sorban lv bjtok -1
;	      C - fejlc kezd oszloppozcija
;	     DE - a kitlt adatokra mutat
;	out: -
;
fk_fihd:push	bc
	ld	a,IY_HEADLN
	call	fk_vid
	ld	bc,-128			; BC = -2 * 64 (2 sornyi eltols)
	add	hl,bc			; HL a fejlc bal fels sarkra mutat
	pop	bc
	ld	c,b			; egy fejlc sorban lv bjtok szma C-be
fk_fih0:ld	a,(de)
	inc	de
	or	a
	ret	z			; visszatrs, ha 0 a sorok szma (lezr nulla)
	ld	b,a
	ld	a,(de)
	inc	de
	push	de
fk_fih1:push	bc
	push	hl			; sor kezdete a verembe
	ld	d,h			; DE= HL + 1
	ld	e,l
	inc	de
	ld	(hl),a
	ld	b,000h			; BC= egy fejlc sor hossza
	ldir				; egy sor kitltse
	pop	hl
	ld	c,64			; BC= eltols a kvetkez sor elejhez
	add	hl,bc
	pop	bc
	djnz	fk_fih1
	pop	de
	jp	fk_fih0

;
;	Fejlc-kitlt adatok (sorok szma, kitlt adat)
;
fv_fihdat
	.db	1, 00Fh
	.db	1, 0F0h
	.db	9, 0FFh
	.db	1, 0F0h
	.db	000h

;
;	Kppontadatok a keret sarkainak megrajzolshoz
;	formtum: hossz, adatbjt1, adatbjt2 ...
;
fv_bfker										; 4-szn mdban
	.db	004h,0F0h,0C3h,084h,084h						; keret  bal-fels sarknak lekerektse
	.db	00Ch,0F0h,0C3h,0B4h,0B5h,07Bh,07Bh,07Bh,07Bh,07Bh,073h,073h,070h 	; fejlc bal-fels sarknak lekerektse
	.db	00Ch,03Ch,0B4h,0B4h,0B4h,0B4h,0B4h,0B4h,0B4h,087h,080h,080h,080h	; fejlc jobb oldala


;
;	Adatok 2-szn mdhoz
;
fv_fihdat2
	.db	2, 000h
	.db	9, 0FFh
	.db	000h

fv_bfker2										; 2-szn mdban
	.db	004h,000h,00Fh,030h,030h						; keret  bal-fels sarknak lekerektse


;
fv_pnul	.db	000h,000h,000h,000h		; teljesen fekete paletta


;
;	Alap 4-szn egypaneles md
;
fv_vmod0:
	.db	001h				; grafikus md -> 4 szn
	.db	011h,000h,055h,004h		; sttkkeszld, fekete, fehr, sttvrs
	.db	3				; az oszlopfejlcek sora
	.db	fst_ln				; az els bejegyzst tartalmaz sor a kpernyn
	.db	lst_ln				; az utols bejegyzs sora
	.db	24				; a legals sszegz sor
	.db	3				; a nv oszlop X pozcija
	.db	28				; panelsorszm X pozcija
	.db	31				; kirhat utvonalnv hossz
	.db	3				; kirand oszlopok szma (nv, kit, mret)
	.db	lst_ln - fst_ln + 1		; maximlisan kirhat sorok szma
	.db	(lst_ln - fst_ln) * 10		; scroll-ozsnl msoland TV sorok szma
	.db	4				; kivlasztott sor invertlsi kezd oszlopa
	.db	56; 50				; kivlasztott sor invertlsi hossza bjtban
	.db	2				; invertls kezd oszlopa
	.db	60				; teljes sor invertls hossza bjtban
	.db	1				; httr szn az tvonal s zenet sorhoz
	.db	2				; bet szn az tvonal s zenet sorhoz
	.db	0F0h				; kitlt bjt az tvonal s zenet sor trlshez

;
;	2-szn egypaneles md
;
fv_vmod1:
	.db	000h				; grafikus md -> 2 szn
	.db	001h,054h,000h,000h		; sttkk, srga (fehr: 55h)
	.db	2				; az oszlopfejlcek sora
	.db	3				; az els bejegyzst tartalmaz sor a kpernyn
	.db	22				; az utols bejegyzs sora
	.db	24				; a legals sszegz sor
	.db	4				; a nv oszlop X pozcija
	.db	60				; panelsorszm X pozcija
	.db	60				; kirhat utvonalnv hossz
	.db	5				; kirand oszlopok szma (nv, kit, mret, dtum, attr.)
	.db	22 - 3 + 1			; maximlisan kirhat sorok szma
	.db	(22 - 3) * 10			; scroll-ozsnl msoland TV sorok szma
	.db	2				; kivlasztott sor invertlsnak kezdete
	.db	60;48				; kivlasztott sor invertlt bjtjainak szma
	.db	1				; teljes sor invertlsnak kezdete bjtban
	.db	62				; invertland teljes sor hossza bjtban
	.db	0				; httr szn az tvonal s zenet sorhoz
	.db	1				; bet szn az tvonal s zenet sorhoz
	.db	000h				; kitlt bjt az tvonal s zenet sor trlshez

;
;	Kt-paneles md
;
fv_vmod2:
	.db	020h				; grafikus md -> 2 szn, 2 panel
	.db	001h,054h,000h,000h		; sttkk, srga (fehr: 55h)
	.db	2				; az oszlopfejlcek sora
	.db	3				; az els bejegyzst tartalmaz sor a kpernyn
	.db	20				; az utols bejegyzs sora
	.db	22				; a legals sszegz sor
	.db	4				; a nv oszlop X pozcija
	.db	29				; panelsorszm X pozcija
	.db	29				; kirhat utvonalnv hossz
	.db	3				; kirand oszlopok szma (nv, kit, mret)
	.db	20 - 3 + 1			; maximlisan kirhat sorok szma
	.db	(20 - 3) * 10			; scroll-ozsnl msoland TV sorok szma
	.db	2				; kivlasztott sor invertlsi kezd oszlopa
	.db	28				; kivlasztott sor invertlsi hossza bjtban
	.db	1				; invertls kezd oszlopa
	.db	30				; teljes sor invertls hossza bjtban
	.db	0				; httr szn az tvonal s zenet sorhoz
	.db	1				; bet szn az tvonal s zenet sorhoz
	.db	000h				; kitlt bjt az tvonal s zenet sor trlshez


;
;	Palettaregiszterek belltsa
;	in:  -
;	out: DE - megrzdik
;
fk_pal0:ld	hl,fv_pnul		; teljesen fekete paletta belltsa
	jr	fk_pal1
;
fk_pal:	push	iy			; az aktulis megjelentsi paletta belltsa
	pop	hl
	inc	hl			; a paletta adatok az IY+1 cmen vannak
fk_pal1:ld	b,004h			; B= belltand paletta-regiszterek szma (4)
	ld	c,05Fh			; C= paletta-regiszterek I/O cme -1
fk_pal2:inc	c			; regisztercm nvelse
	outi				; regiszter lltsa, B=B-1
	jr	nz,fk_pal2
	ret

;
;	Panelek kirajzolsa
;	in:  E - 1 ->teljes frissts  0-> csak az offszettel megadott fl kpernyt kell frissteni
;	out: -
;
fk_bord_wrap:
	ld	a,(akt_panel)
	ld	c,a
	push	bc			; aktulis panel mentse
	call	fk_psl2			; namecl_offs frisstse, ha esetleg vltozott a megjelentsi md
	ld	a,e			; teljes frissts flag A reg.-be
	ld	e,1			; teljes kpernytrls
	jr	nc,fk_bwr1		; ugrs, ha egypaneles md
	rra
	jr	nc,fk_bwr0		; ugrs, ha nem kell teljes frissts kt panel esetn
	ld	e,0			; 1. panel kivlasztsa
	call	fk_psel
	ld	e,1			; teljes kpernytrls
	call	fk_bord			; 1. panel kirajzolsa
	ld	e,1
	call	fk_psel			; 2. panel kivlasztsa, majd kirajzolsa
fk_bwr0:ld	e,0
fk_bwr1:call	fk_bord
	pop	de
	call	fk_psel			; aktulis panel visszalltsa, ha szksges
	call	fk_pal			; paletta belltsa
	ret


;
;	Httr s keret rajzolsa, statikus szvegek kirsa
;	in:  E - 1-> a teljes kpernyt trlni kell
;	out: -
;
fk_bord:xor	a
	out	(000h),a		; BORDER = 0
	call	fk_pal0			; teljesen fekete paletta belltsa
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa (ZF=0 -> 4-szn md)
	ld	c,a			; videmd C-be
	ld	a,e
	rra				; fl kperny flag CY-be
	push	af			; flag-ek a verembe is (CY s ZF)
	jr	nc,fk_bor0
	call	ed_vidmode		; videmd belltsa, kperny trlse
	call	fk_pal0			; teljesen fekete paletta belltsa ismt
fk_bor0:ld	a,VID_PAGE_CFG		; A reg.= U0, U1, VID, CART (v. IOMEM)
	di
	out	(002h),a		; memrialapozs belltsa
	pop	af			; flag-ek visszatltse
	jr	nz,fk_bor5		; ugrs, ha 4-szn md
;
	ld	a,(namecl_offs)		; A reg.= keret oldal irny eltolsa (0 v. 32)
	jr	c,fk_bor3		; ugrs, ha nem flkpernyt kell trlni
	ld	l,a
	ld	h,080h			; HL= a frisstend kpernyfl kezdete
	ld	de,0020h		; DE= soremels rtke (valamint: D= kitlt bjt  E= bjtok szma egy sorban)
	ld	c,240			; C = 240 sort trl
fk_bor1:ld	b,e
fk_bor2:ld	(hl),d			; egy sor trlse
	inc	hl
	djnz	fk_bor2
	add	hl,de			; kvetkez sor
	dec	c
	jr	nz,fk_bor1
fk_bor3:ld	l,a			; HL= keret oldal irny eltolsa (0 v. 32)
	ld	h,000h
	ld	de,08000h + (5 * 64)	; DE= keret kezdcme alapesetben
	add	hl,de			; HL= keret bal fels sarka
	push	af
	push	hl
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	020h			; 2 paneles md kimaszkolsa a videmd rtkbl
	xor	03Fh			; A reg. = keret szlessge - 1 (31 v. 63)
	call	fk_kpan			; ngyszgletes keret rajzolsa
	pop	hl
	pop	af
	ld	de,fv_bfker2		; DE = sarok adatok cme lekerektett kerethez
	or	a
	call	z,fk_sark		; keret lekerektse
	ld	de,fv_fihdat2		; DE = fejlc kitlt adatok cme
	call	fk_istr			; C  = fejlc sznezs kezd oszloppozcija
	ld	b,IY_INVFULL		; B  = egy fejlc sorban lv bjtok -1
	dec	b
	call	fk_fihd			; fejlc sznezse
	ld	a,(namecl_offs)
	ld	bc,0301h		; tvonal string pozicija: X=3 Y=1
	add	a,b
	ld	b,a
	jr	fk_bor6
;
fk_bor5:ld	hl,08000h + ((fst_ln - 1) * 640) - (4 * 64)
	push	hl			; referenciapont a verembe is (4 sorral feljebb kezdi mint a scroll van)
	call	fk_filn			; tvonal s zenet sorok sznezse
	pop	hl
	push	hl
	call	fk_bold			; ngyszgletes keret rajzolsa
	ld	c,IY_NAMECL		; C = fejlc kezd oszloppozcija
	ld	a,IY_PNUMCL		; A reg.= fejlc vge -1 karakter
	inc	a
	sub	c			; A reg.= egy fejlc sorban lv karakterek
	add	a,a			; A reg.= egy fejlc sorban lv bjtok
	sla	c			; 4-szn mdban egy karakter 2 bjt szles
	pop	hl			; HL = keret kezdete
	push	hl			; keret kezdete vissza a verembe
	ld	b,0FEh			; BC = fejlc kezd oszloppozcija - eltolsi rtk a fejlc fels sorhoz (-8 * 64)
	add	hl,bc
	push	hl
	ld	b,a			; B  = egy fejlc sorban lv bjtok
	ld	e,b
	ld	d,000h			; DE = fejlc vge
	add	hl,de			; HL a fejlc jobb fels sarkra mutat
	pop	de
	ex	(sp),hl
	push	de			; fejlc bal fels sarka
	push	hl			; keret kezdete
	ld	de,fv_fihdat		; DE = fejlc kitlt adatok cme
	call	fk_fihd			; fejlc sznezse
	pop	hl			; HL = keret kezdete
	call	fk_sark			; keret lekerektse
	pop	hl
	dec	hl
	call	fk_sark			; fejlc bal oldal lekerektse
	pop	hl
	call	fk_sark			; fejlc jobb oldala
	ld	bc,0101h		; tvonal string pozicija: X=1 Y=1
;
fk_bor6:ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	call	ed_cpos			; kurzor-pozcionls
	call	fk_ms1			; INK s PAPER belltsa
	ld	hl,(path_ptr)		; az aktulis tvonal kirsa
	ld	bc,SDC_MAX_PATH		; max. karakter tvizsglsa
	xor	a
	cpir				; tvonal-string vgnek megkeresse (B=0 lesz)
	ld	a,c
	sub	SDC_MAX_PATH		; A reg.= sszes karakter a stringben lezr 0-val egytt * (-1)
	ld	c,IY_PATHLEN		; C= a kirhat tvonalnv hossz
	add	a,c
	jr	nc,fk_bor7		; ugrs, ha a panel szlessgnl hosszabb az tvonal string
	ld	hl,(path_ptr)
	call	fk_prn0			; tvonal kirsa az aktulis kurzorpozcitl
	jr	fk_bor8
;
fk_bor7:push	bc			; BC= a teljes kirhat hossz
	ex	de,hl			; az tvonal utols karaktereinek tmsolsa a stringbufferbe
	ld	hl,strbuff-1
	add	hl,bc
	ex	de,hl
	ld	a,-5			; a maximlis hosszbl a bevezet karakterek szmnak levonsa
	add	a,c
	ld	c,a
	dec	hl			; HL a lezr 0-ra mutat
	dec	hl			; HL az tvonal utols karakterre mutat
	lddr
	ld	a,'.'			; tvonalrvidts jelzse kt ponttal
	ld	(de),a
	dec	de
	ld	(de),a
	ld	c,003h			; az tvonal els 3 karakternek tmsolsa (meghajt betjele)
	ld	de,strbuff
	ld	hl,(path_ptr)
	ldir
	pop	bc			; BC a teljes kirand szveg hossza
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa
fk_bor8:ld	de,00203h		; INK= 2  PAPER= 3
	call	ed_setcolors		; INK s PAPER belltsa
	call	fk_head			; oszlopfejlcek kirsa
	ret


;
;-----------------------------------------------------
;	Szabad terlet-kirs funkcii
;-----------------------------------------------------
;
fk_free_wrapper:
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	call	fk_free			; funkci hvsa
	jp	nz,fk_er4a		; ugrs, ha hiba trtnt
	push	af
	jp	fk_er5			; ugrs a befejezsre: gombnyoms, als sor helyrelltsa

;
;-----------------------------------------------------
;	Szabad terlet-kirs kiegszt funkcii
;-----------------------------------------------------
;

fr0text	.text	"Meghajt\223 vizsg\220lata...\000"
fr1text	.text	"Szabad: \000"
fr2text	.text	" a "
fr3text	.text	" kB"
fr4text	.text	"-b\223l"

;
;	Szabad terlet kirsa
;	in:   A - grafikusmd (IY_GRMODE)
;	out:    -
;
fk_free:ld	(fmanid),a		; grafikusmd mentse
	ld	hl,fr0text		; funkcinv kirsa a legals sorba
	call	fk_msg			; zenet kirsa az als sorba
	ld	hl,(path_ptr)
	ld	a,(hl)			; A reg.= aktulis tvonalnvbl a meghajt betjele
	or	a			; ha 000h, akkor a meghajt lista aktulis ellemnek vizsglata
	jr	nz,fk_fre0
	ld	a,(xaktbj)		; kurzor alatti fjlnv indexe
	call	fk_fadr			; HL= fjl bejegyzsnek cme
	ld	a,(hl)			; A reg.= a kurzor alatti meghajt betjele
fk_fre0:sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	b,a
	ld	a,015h			; A = FISH funkci: lemez-foglaltsgi informcik beolvassa
	call	fk_fish			; FISH funkci hvsa
	ld	c,b			; megj.: floppy-n s rgi SD ROM-oknl C=8 a visszatrsi rtk
	ld	b,a			; visszaadja a hibakdot
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	push	bc			; C = szektorok szma alapegysgenknt
	push	de			; DE= alapegysgek szma
	push	hl			; HL= szabad alapegysgek szma
	ld	hl,fr1text		; bevezet szveg kirsa a legals sorba
	call	fk_msg			; zenet kirsa az als sorba
	pop	hl			; elmentett rtkek vissza
	pop	de
	pop	bc
;
	call	fk_frcp			; szabad terlet s teljes kapacits kirsa kB-ban a string bufferbe
;
	call	fk_prn2			; szveg kirsa a pufferbl a kpernyre
	xor	a			; hiba trlse
	ret

;
;	Szabad terlet s teljes kapacits kirsa kB-ban a string bufferbe
;	in:   B - 000h
;	      C - szektorok szma alapegysgenknt
;	     DE - alapegysgek szma
;	     HL - szabad alapegysgek szma
;	     IX - az egysg-ler terlet cme (FISH15 adja vissza, eltolva +8-cal!)
;	out: DE - a lezr nullra mutat a pufferben
;	     CY - CY=0
;
fk_frcp:push	de			; DE= alapegysgek szma
	push	bc			; C = szektorok szma alapegysgenknt
	ld	de,strbuff
	call	fk_frei			; szabad kapacits kirsa
	pop	bc
	pop	hl
	ld	a,(fmanid)		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
	jr	nz,fk_frc0		; ugrs, ha nem 2-szn md
	push	hl
	ld	a,c
	ld	c,003h
	ld	hl,fr2text
	ldir				; " a "
	ld	c,a
	pop	hl
	ld	b,000h			; B= klaszterben adott mret legfels bjtja az egysgler tblzatbl (most nem hasznlt)
	call	fk_frei			; teljes kapacits kirsa
	ld	c,004h
	ld	hl,fr4text
	ldir				; "-bl"
fk_frc0:xor	a
	ld	(de),a			; lezr nulla elhelyezse
	ret

;
;	Klaszter-ben adott mret kiszmolsa kB-ban s kirsa a string bufferbe
;	in:   B - klasztermret legfels bjtja
;	      C - klaszterenknti szektorszm
;	     DE - kezd pozci a string bufferben
;	     HL - mret klaszterben
;	out:  A - SPACE kdja (020h)
;	     BC - 0000h
;	     DE - az utols karakter utn mutat a pufferben
;
fk_frei:xor	a			; eredmny fels bitjei A reg.-ben lesznek
	jr	fk_fre2
;
fk_fre1:add	hl,hl			; B:HL (klaszterek szma) szorzsa a klaszterenknti szektorszmmal
	rl	b
	rla
fk_fre2:srl	c			; C jobbra lptetse 1-el (klaszterenknti szektorszm)
	jr	nz,fk_fre1		; ugrs, ha nem nulla
fk_fre3:srl	a
	rr	b
	rr	h			; A:B:HL osztsa 2-vel -> szabad terlet kbjtban
	rr	l
	ld	(numbuff_L),hl		; als 16 bit
	ld	hl,numbuff_H
	ld	(hl),b			; fels 16 bit
	inc	hl
	ld	(hl),a
	push	de
	call	fk_ascc			; szm konvertlsa ASCII-ba
	ex	de,hl			; HL= szveg vge
	pop	de			; DE= szveg kezdete
	xor	a
	ld	(hl),a			; lezr nulla elhelyezse a konvertlt szm utn
	sbc	hl,de
	ld	b,l			; B = teljes szveg hossza
	ld	l,e			; HL= szveg kezdete
	ld	h,d
	call	fk_chk			; bevezet SPACE karakterek levgsa
	ld	c,b
	ld	b,000h
	jr	z,fk_fre4		; ugrs, ha 0 lett a hasznos hossz (BC=0)
	ldir				; hasznos szveg elbbre msolsa
fk_fre4:ld	c,003h
	ld	hl,fr3text
	ldir				; " kB"
	ret

;
;	Adott karakter ellenrzse a szvegben
;	in:   A - ellenrzend karakter (fk_chk1-nl belpve)
;	      B - szveg hossza
;	     HL - szveg kezdete
;	out:  A - megrzdik
;	      B - htramaradt hossz
;	     HL - utoljra ellenrztt karakter cme
;	     ZF - 0: tallt nem illeszked karaktert  1: mind illeszkedett
;
fk_chk:	ld	a,020h			; A reg.= SPACE kdja
fk_chk1:cp	(hl)
	ret	nz
	inc	hl
	djnz	fk_chk1
	ret

;
;-----------------------------------------------------
;	ASCII formtumra konvertl rutinok
;-----------------------------------------------------
;

;
;	BIN->BCD->ASCII konvertls
;
;	in: HL - 32 bites binris szm fels bjtjnak cme
;	    DE - ASCII szm els karakternek cme
;
fk_ascc:push	de			; ASCII szm puffer-cmnek mentse
	xor	a
	ld	de,bcdMSB
	ld	b,5			; B=BCD szm hossza bjtban (5=>10 szmjegy)
ascc0:	ld	(de),a			; BCD szm nullzsa
	inc	de
	djnz	ascc0
	ld	b,04			; binris szm hossza bjtban
	ld	c,08			; 8-szor lpteti balra HL ltal mutatott bjtot
ascc1:	push	bc
ascc2:	ld	de,bcdLSB		; DE=BCD szm als bjtja
	ld	b,5			; B=BCD szm hossza bjtban
	rlc	(hl)
ascc3:	ld	a,(de)
	adc	a,a
	daa
	ld	(de),a
	dec	de
	djnz	ascc3
	dec	c
	jr	nz,ascc2
	dec	hl
	pop	bc
	djnz	ascc1
	ld	de,bcdMSB		; BCD konvertlsa ASCII-ba, DE=BCD fels bjtja
	pop	hl			; HL=ASCII szm els karaktere
	ld	b,5			; B=BCD szm hossza bjtban
ascc4:	ld	a,(de)			; a kezd 0-k helyettestse SPACE-el
	and	0F0h
	jr	nz,ascc5
	ld	(hl),20h		; SPACE bersa
	inc	hl
	ld	a,(de)
	and	0Fh
	jr	nz,ascc6
	ld	(hl),20h		; SPACE bersa
	inc	hl
	inc	de
	djnz	ascc4
	dec	hl
	ld	(hl),30h		; ha a szm=0, akkor az utols bjtra '0' kerl
	inc	hl
	ex	de,hl
	ret
ascc5:	ld	a,(de)			; hasznos szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
ascc6:	ld	a,(de)
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
	inc	de
	djnz	ascc5
	ex	de,hl
	ret

;
;	Egybjtos BIN szm konvertlsa 2-szmjegy DEC ASCII-ba
;
;	in:  A - binris szm
;	    DE - hova
;
fk_bcon:ld	c,a			; C-bl lpnek ki a bitek
	xor	a			; A-ban lesz a kt helyirtk BCD szm
	ld	b,08			; 8-szor lpteti balra
bcon0:	rlc	c
	adc	a,a
	daa
	djnz	bcon0
bcon1:	ld	b,a			; BCD szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ld	a,b
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ret

;
;	Ktbjtos BIN szm konvertlsa 4-szmjegy DEC ASCII-ba
;
;	in: HL - binris szm
;	    DE - hova
;
fk_dcon:push	de
	ld	de,0000h		; DE-ben lesz a 4-jegy BCD szm
	ld	b,08			; 8-szor lpteti balra H-t
dcon0:	rlc	h
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon0
	ld	b,08			; 8-szor lpteti balra L-t
dcon1:	rlc	l
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon1
	pop	hl			; BCD szmjegyek konvertlsa ASCII-ba
	ex	de,hl
	ld	a,h
	call	bcon1
	ld	a,l
	call	bcon1
	ret

;
;	BIN->dtum konvertls
;
;	in: HL - dtum cme
;	    DE - ASCII szm els karakternek cme
;
fk_date:ld	b,0			; v
	ld	c,(hl)
	srl	c
	push	hl
	ld	hl,1980
	add	hl,bc
	call	fk_dcon
	ld	a,'.'
	ld	(de),a
	inc	de
	pop	hl
	ld	a,(hl)			; hnap
	dec	hl
	rra
	ld	a,(hl)
	rra
	rra
	rra
	rra
	rra
	and	0Fh
	call	fk_bcon
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	a,(hl)			; nap
	and	1Fh
	call	fk_bcon
	ret

;
;	BIN->id konvertls
;
;	in: HL - id cme
;	    DE - ASCII szm els karakternek cme
;
fk_time:ld	a,(hl)			; ra
	rra
	rra
	rra
	and	1Fh
	call	fk_bcon
	ld	a,':'
	ld	(de),a
	inc	de
	ld	a,(hl)			; perc
	dec	hl
	ld	b,(hl)
	rl	b
	rla
	rl	b
	rla
	rl	b
	rla
	and	3Fh
	call	fk_bcon
	dec	hl
	ret

;
;	Angol kisbet nagybetv alaktsa
;	in:   A - ASCII karakterkd
;	out:  A - nagybetv alaktott karakter, ha A < 128
;	     CY - vltozatlan marad
;
fk_nagy:bit	7,a
	ret	nz
	bit	6,a
	ret	z
	res	5,a
	ret	
;
.end
